SystemOrganization addCategory: #'Alt-Browser'!
SystemOrganization addCategory: #'Alt-Browser-Commands'!
SystemOrganization addCategory: #'Alt-Browser-Tests'!

CodeHolder subclass: #AltBrowserCodeModel
	instanceVariableNames: 'browser aboutToStyle behavior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!AltBrowserCodeModel commentStamp: '<historical>' prior: 0!
An AltBrowserCodeModel is in charge of handling the text morph of the Alt Browser.

Instance Variables
	aboutToStyle:		<Boolean>
	behavior:		<Class>
	browser:		<AltBrowserModel>

aboutToStyle
	- Say if the next code is to be styled (syntax coloring) or not.

behavior
	- The behavior for the styler ?

browser
	- The instance of the AltBrowserModel we are in
!

!AltBrowserCodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/27/2012 20:04'!
aboutToStyle: aBoolean
	aboutToStyle := aBoolean! !

!AltBrowserCodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/26/2012 13:20'!
browser: anAltBrowserModel
	browser := anAltBrowserModel! !

!AltBrowserCodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/30/2012 11:45'!
buildTextMenu: aMenu
	^ browser buildTextMenu: aMenu! !

!AltBrowserCodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/26/2012 13:31'!
contents: aStringOrText
	super contents: aStringOrText.
	self contentsChanged! !

!AltBrowserCodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/26/2012 14:22'!
readSelection
	^ browser textMorph readSelection! !

!AltBrowserCodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/26/2012 13:22'!
selectedClass
	"Hope this is the one really needed."

	^ browser selectedNode isNil
		ifTrue: [ nil ]
		ifFalse: [ browser selectedNode sourceClass ]! !

!AltBrowserCodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/27/2012 20:09'!
shoutAboutToStyle: ignored
	aboutToStyle isNil
		ifTrue: [ aboutToStyle := false ].
	^ aboutToStyle! !

Announcement subclass: #AltNodeAnnouncement
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!AltNodeAnnouncement commentStamp: '<historical>' prior: 0!
The abstract node announcement.

Beware, unexpected behavior!! Announcement matching for actions matches also subclasses (what a strange idea?).

Buggy previous code: AltNodeRemoved has AltNodeAdded as superclass; on AltNodeRemoved both AltNodeAdded and AltNodeRemoved would match and trigger actions.
!

AltNodeAnnouncement subclass: #AltNodeAdded
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!AltNodeAdded commentStamp: '<historical>' prior: 0!
This announce an added node in the tree.
!

!AltNodeAnnouncement class methodsFor: 'instance creation' stamp: 'ThierryGoubier 8/29/2012 22:33'!
node: aNode
	^ self new node: aNode! !

!AltNodeAnnouncement methodsFor: 'accessing' stamp: 'ThierryGoubier 8/29/2012 22:28'!
node
	^ node! !

!AltNodeAnnouncement methodsFor: 'accessing' stamp: 'ThierryGoubier 8/29/2012 22:28'!
node: anObject
	node := anObject! !

AltNodeAnnouncement subclass: #AltNodeRebuilt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!AltNodeRebuilt commentStamp: '<historical>' prior: 0!
This announcement mark a node rebuilt.!

AltNodeAnnouncement subclass: #AltNodeRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!AltNodeRemoved commentStamp: '<historical>' prior: 0!
This class mark the removal of a node.!

AltNodeAnnouncement subclass: #AltNodeUpdated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

Announcement subclass: #AltRootsReset
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!AltRootsReset commentStamp: '<historical>' prior: 0!
This announcement is for resetting all roots from the AltBrowser class side.!

CustomHelp subclass: #AltBrowserHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!AltBrowserHelp commentStamp: '<historical>' prior: 0!
This is the help for the AltBrowser. Tries to hold some documentation about what is going on.
!

!AltBrowserHelp class methodsFor: 'accessing' stamp: 'ThierryGoubier 9/1/2012 18:46'!
bookName
	^ 'The Alternative Browser Help'! !

!AltBrowserHelp class methodsFor: 'pages' stamp: 'ThierryGoubier 9/1/2012 18:52'!
introduction
	^ HelpTopic
		title: 'Introduction'
		contents:
'The Alternative System Browser


The AltBrowser, for short, is a replacement for the standard or improved system browser. Its aims are to present a powerfull, yet simple, view of your Smalltalk Image to explore and program with.'
		! !

!AltBrowserHelp class methodsFor: 'accessing' stamp: 'ThierryGoubier 9/1/2012 18:53'!
pages
	^ #(introduction)! !

!AltBrowserHelp class methodsFor: 'pages' stamp: 'ThierryGoubier 9/6/2012 21:44'!
status
	^ HelpTopic
		title: 'Status'
		contents:
'Status is : moving forward quite well. However, it has a tendency to expose bugs in RPackage which makes things the more difficult.'
		! !

KMDispatcher subclass: #AltKMDispatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!AltKMDispatcher commentStamp: '<historical>' prior: 0!
Here only to remove a bad behavior in KMDispatcher. See how the standard KMDispatcher is replaced by this one in AltBrowser>>updateTextKeymaps.

Also remove the staticTargets targets, so that we may have a text editor without any legacy shortcuts.
!

!AltKMDispatcher methodsFor: 'dispatching' stamp: 'ThierryGoubier 10/1/2012 22:55'!
keymapObservers
	| o |
	(o := OrderedCollection with: self perInstanceTarget)
		addAll: self targets.
	^ o! !

MorphTreeNodeModel subclass: #ABTreeNodeModel
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABTreeNodeModel commentStamp: '<historical>' prior: 0!
An ABTreeNodeModel represent a node for the tree. It reroutes most of it's request to the underlying item.

It caches its contents however.!

!ABTreeNodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/3/2012 21:58'!
addChild: anItem
	"Add a child, but do it according to it's position."

	| d newNode |
	d := self childrenItems indexOf: anItem.
	d < 1 ifTrue: [^ self].
	contents add: (newNode := self childNodeFromItem: anItem) beforeIndex: d.
	^ newNode! !

!ABTreeNodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/25/2012 16:53'!
asText
	^ item asText! !

!ABTreeNodeModel methodsFor: 'querying' stamp: 'ThierryGoubier 7/25/2012 23:23'!
buildTextMenu: aMenu on: aTarget with: aRequestor
	^ self item buildTextMenu: aMenu on: aTarget with: aRequestor! !

!ABTreeNodeModel methodsFor: 'querying' stamp: 'ThierryGoubier 7/30/2012 16:54'!
buildTreeMenu: aMenu on: aTarget with: aRequestor
	^ self item buildTreeMenu: aMenu on: aTarget with: aRequestor! !

!ABTreeNodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 7/19/2012 22:33'!
childrenItems
	^ item contents! !

!ABTreeNodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 7/19/2012 22:26'!
contents
	contents isNil
		ifTrue: [ contents := super contents ].
	^ contents! !

!ABTreeNodeModel methodsFor: 'testing' stamp: 'ThierryGoubier 7/27/2012 21:42'!
contentsNotNil
	^ contents notNil! !

!ABTreeNodeModel methodsFor: 'querying' stamp: 'ThierryGoubier 7/26/2012 23:16'!
findItem: anItem
	"searching for an item, returns a node."

	self item == anItem
		ifTrue: [ ^ self ].
	contents notNil
		ifTrue: [ 
			contents
				do: [ :e | 
					| s |
					(s := e findItem: anItem) notNil
						ifTrue: [ ^ s ] ] ].
	^ nil! !

!ABTreeNodeModel methodsFor: 'querying' stamp: 'ThierryGoubier 8/31/2012 17:27'!
forceFindItem: anItem
	"searching for an item, returns a node."

	self item == anItem
		ifTrue: [ ^ self ].
	self contents
		do: [ :e | 
			| s |
			(s := e forceFindItem: anItem) notNil
				ifTrue: [ ^ s ] ].
	^ nil! !

!ABTreeNodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 7/19/2012 23:24'!
isStyled
	^ item isStyled! !

!ABTreeNodeModel methodsFor: 'testing' stamp: 'ThierryGoubier 7/31/2012 14:44'!
isTreeNodeModel
	^ true! !

!ABTreeNodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/4/2012 12:45'!
item
	^ item! !

!ABTreeNodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/30/2012 18:55'!
rebuildChildren
	"Force a rebuild of the children, including on the item."

	item rebuildContents.
	self rebuildContents! !

!ABTreeNodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/30/2012 18:55'!
rebuildContents
	"Force a rebuild of the contents."
	
	contents notNil
		ifTrue: [ 
			contents := (self childrenItems
				collect: [ :i | 
					| n |
					n := contents detect: [ :e | e item == i ] ifNone: [ nil ].
					n isNil
						ifTrue: [ self childNodeFromItem: i ]
						ifFalse: [ n ] ]) asOrderedCollection ]! !

!ABTreeNodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 7/19/2012 22:27'!
sourceClass
	^ item sourceClass! !

!ABTreeNodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 7/19/2012 22:27'!
sourceCode
	^ item sourceCode! !

!ABTreeNodeModel methodsFor: 'accessing' stamp: 'ThierryGoubier 9/21/2012 16:15'!
title
	^ item title! !

!ABTreeNodeModel methodsFor: 'querying' stamp: 'ThierryGoubier 7/31/2012 10:35'!
wantsDroppedObject: anotherItem
	"So far, this is unused. The wrapper never connect to that here. What is needed is to customize the PluggableTreeMorph, which is the model behind all elements of the tree."

	^ self item wantsDroppedObject: anotherItem! !

MorphTreeModel subclass: #AltBrowser
	instanceVariableNames: 'source tree history window treeMorph textMorph'
	classVariableNames: 'announcer debug rootItems temporary'
	poolDictionaries: ''
	category: 'Alt-Browser'!

!AltBrowser commentStamp: '<historical>' prior: 0!
An AltBrowserModel represent the base for a Morph-based GUI. It takes from the Jejak JViewer.!

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/18/2012 10:42'!
aCategoryRemoved: anEvent
	"Ok, a class category was removed. What has this become with RPackage ?"

	| node r |
	node := self rootItems
		detect: [ :e | (r := e findClassCategory: anEvent categoryName) notNil ] ifNone: [^self].
	r parentNode contents remove: r.
	announcer announce: (AltNodeRemoved node: r)! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/3/2012 16:14'!
aClassAdded: anEvent
	"Ok, a class was added. Find the package it belongs to (or none)."

	| node r package cat |
	package := anEvent classAdded package.
	self assert: package notNil.
	node := self rootItems detect: [ :e | (r := e findPackage: package) notNil ] ifNone: [ ^ self ].
	r contentsNotNil
		ifTrue: [ 
			| classNode |
			classNode := r addChild: anEvent classAdded.
			announcer announce: (AltNodeAdded node: classNode) ]! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 11/21/2012 13:41'!
aClassCommented: anEvent
	"Find the comment node and refresh it (or the class node, should be good enough)."

	"Refreshing the class node is bad, because then the comment node is recreated and the accept routine looses the focus."

	| node r |
	node := self rootItems detect: [ :e | (r := e findClass: anEvent classCommented) notNil ].
	self aNodeToUpdate: r contents second! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/3/2012 16:14'!
aClassRemoved: anEvent
	"Ok, a class was removed. If this class has extensions, it should be removed from more than one place."

	| node r o |
	o := OrderedCollection new.
	node := self rootItems
		do: [ :e | 
			(r := e findAllClass: anEvent classRemoved) notNil
				ifTrue: [ o addAll: r ] ].
	o
		do: [ :e | self aNodeToRebuilt: e parentNode ]! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/15/2012 14:29'!
aClassRenamed: anEvent
	"Find the class node, and rebuilt the parent? Overall, there is a lack of correct model integration in those structures."

	| node r |
	node := self rootItems detect: [ :e | (r := e findClass: anEvent classRenamed) notNil ].
	self aNodeToRebuilt: r parentNode! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/3/2012 16:14'!
aClassReorganized: anEvent
	"Ok, a class was reorganised (a new protocol, for example). It seems I need to rebuilt all nodes on that class. It's not so simple than calling the new rebuilt; we also need to remove the old items or add new ones."

	| node r o |
	o := OrderedCollection new.
	node := self rootItems
		do: [ :e | 
			(r := e findAllClass: anEvent classReorganized) notNil
				ifTrue: [ o addAll: r ] ].
	o do: [ :each | self aNodeToRebuilt: each ]! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/23/2012 14:04'!
aClassRepackaged: anEvent
	"Ok, a class was repackaged. Update old and new package."

	| newPackage oldPackage cat |
	newPackage := anEvent newPackage.
	oldPackage := anEvent oldPackage.
	self assert: anEvent classRepackaged package = newPackage.
	{oldPackage.
	newPackage}
		do: [ :p | 
			| r |
			self rootItems detect: [ :e | (r := e findPackage: p) notNil ] ifNone: [ r := nil ].
			r notNil
				ifTrue: [ self aNodeToRebuilt: r ] ]! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/4/2012 21:18'!
aMCWorkingCopyCreated: anEvent
	"Only case where we don't use a #findXXX: on the root items."

	"Done for the RPackage change. Need to test."

	| packageSet packageName cat node item |
	packageSet := anEvent workingCopy packageSet.
	packageName := packageSet packageName.
	item := packageSet packages size = 1
		ifTrue: [ packageSet packages first ]
		ifFalse: [ packageName -> packageSet packages asOrderedCollection ].
	cat := packageName copyUpTo: $-.
	node := self rootItems detect: [ :e | (e isKindOf: ABPackageCategoryNode) and: [ e item key = cat ] ] ifNone: [ nil ].
	node notNil
		ifTrue: [ 
			| packageNode |
			node item value add: item.
			packageNode := node addChild: item.
			announcer announce: (AltNodeAdded node: packageNode) ]
		ifFalse: [ 
			node := packageSet packages size = 1
				ifTrue: [ ABPackageNode with: item ]
				ifFalse: [ ABPackageCategoryNode with: item ].
			self rootItems add: node.
			announcer announce: (AltNodeAdded node: node) ]! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/3/2012 16:15'!
aMCWorkingCopyDeleted: anEvent
	"Depending on the MCPackage, this may appear as a package category or as a RPackage."

	| aPackageSet package cat node r |
	aPackageSet := anEvent workingCopy packageSet.
	self rootItems contents
		detect: [ :e | (node := e findPackage: aPackageSet packages first) notNil ]
		ifNone: [ ^ self ].
	aPackageSet packages size > 1
		ifTrue: [ node := node parentNode ].
	node parentNode notNil
		ifTrue: [ node parentNode removeChildItem: node ]
		ifFalse: [ self roots remove: node ].
	announcer announce: (AltNodeRemoved node: r)! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/3/2012 16:15'!
aMCWorkingCopyModified: anEvent
	"Ok, should force a change in look for the relevant object in the trees."

	| packageSet node |
	packageSet := anEvent package.
	self rootItems detect: [ :e | (node := e findPackageSet: packageSet) notNil ] ifNone: [ nil ].
	node notNil
		ifTrue: [ self aNodeToUpdate: node ]! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/3/2012 16:15'!
aMethodAdded: anEvent
	"Ok, a method was added. Things to search for: extensions!! If the method is an extension, update that part as well (and at the package extension level, since it may be necessary to add the class node as well). Use the findAllMethodParents: for that."

	"Problem : if there isn't any method yet, then the current method category will be replaced by the 'as yet unclassified' category, and the update won't work as expected."

	| mCNodes |
	mCNodes := OrderedCollection new.
	self rootItems
		do: [ :root | 
			| res |
			res := root findAllClass: anEvent methodClass.
			res notNil
				ifTrue: [ mCNodes addAll: res ] ].
	mCNodes
		do: [ :each | 
			| pNode |
			pNode := each findMethodCategory: anEvent protocol in: anEvent methodClass.
			(each contents detect: [ :i | i item = 'no messages' ] ifNone: [ nil ]) isNil
				ifFalse: [ self aNodeToRebuilt: each ]
				ifTrue: [ self aNodeToRebuilt: pNode ] ]! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/3/2012 17:04'!
aMethodRecategorized: anEvent
	"Ok, a method protocol has changed. Don't forget the method may be in multiple places (extensions) but this may be handled by other announcements ."

	"TOCHECK: if a protocol is removed or added because of this event, suppose that the system will send a ClassReorganized event as well."

	| mCNodes |
	mCNodes := OrderedCollection new.
	self rootItems
		do: [ :root | 
			| res |
			res := root findAllClass: anEvent methodClass.
			res notNil
				ifTrue: [ mCNodes addAll: res ] ].
	mCNodes
		do: [ :each | 
			| pNode pNode2 |
			pNode := each findMethodCategory: anEvent oldProtocol in: anEvent methodClass.
			self aNodeToRebuilt: pNode.
			pNode2 := each findMethodCategory: anEvent newProtocol in: anEvent methodClass.
			pNode2 ~= pNode
				ifTrue: [ self aNodeToRebuilt: pNode2 ] ]! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/3/2012 16:08'!
aMethodRemoved: anEvent
	"Ok, a method was removed. Don't forget the method may be in multiple places."

	"Change this code; search for places where the method is visible (extensions and protocols)."

	"Bug: when removing a method, the method having already been removed from the system makes the search for the parent fail... :palm:"

	| mCNodes |
	mCNodes := OrderedCollection new.
	self rootItems
		do: [ :root | 
			| res |
			res := root findAllClass: anEvent methodClass.
			res notNil
				ifTrue: [ mCNodes addAll: res ] ].
	mCNodes
		do: [ :each | 
			| pNode |
			pNode := each findMethodCategory: anEvent protocol in: anEvent methodClass.
			(anEvent protocol = #'as yet unclassified' and: [ pNode isNil ])
				ifTrue: [ self aNodeToRebuilt: each ]
				ifFalse: [ self aNodeToRebuilt: pNode ] ]! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/3/2012 15:52'!
aNodeToRebuilt: r
	"Ok. The clever updating is done and it works rather nicely. Will help simplify the extensions to IndentingListItemMorph."

	r isNil ifTrue: [ ^ self ].
	r rebuildContents.
	announcer announce: (AltNodeRebuilt node: r)! !

!AltBrowser class methodsFor: 'updating' stamp: 'ThierryGoubier 10/3/2012 15:53'!
aNodeToUpdate: r
	"Update the node without rebuilding it. Good for PackageSet which may change its label based on its contents."

	r isNil ifTrue: [ ^ self ].
	announcer announce: (AltNodeUpdated node: r)! !

!AltBrowser class methodsFor: 'accessing' stamp: 'ThierryGoubier 10/3/2012 16:05'!
announcer
	^ announcer! !

!AltBrowser class methodsFor: 'debug' stamp: 'ThierryGoubier 10/3/2012 15:29'!
debug
	debug isNil
		ifTrue: [ debug := false ].
	^ debug! !

!AltBrowser class methodsFor: 'private' stamp: 'ThierryGoubier 11/20/2012 08:16'!
defaultPackageCategoriesNames
	"As it says: categories for packages who don't use the - convention. But also the place where we may start organizing nicely the system to have a better structure. Do a reset of the AltBrowser to see the changes in the opened browsers."
	
	"AltBrowser reset."
	
	^ #('System'
		#('GUI' 'Graphics' 'Morphic' 'Balloon' 'FreeType' 'Polymorph' 'Spec' 'UIManager' 'UI' 'GroupManagerUI' 'Growl' 'Keymapping' 'FamFam' 'EventModel' 'MenuRegistration' 'HistoryCollection')
		#('Core' 'Kernel' 'Collections' 'Text' 'Compiler' 'EmergencyEvaluator' 'Regex' 'Multilingual' 'Announcements' 'Transcript' 'Traits' 'NewClassOrganizer')
		#('Development' 'AST' 'Refactoring' 'Tools' 'Nautilus' 'NonInteractiveTranscript' 'SUnit' 'Tests' 'Shout' 'SmaCC' 'NECompletion' 'NOCompletion' 'Manifest')
		#('Networking' 'Network' 'Zodiac' 'Zinc' 'Compression')
		#('Packages' 'PackageInfo' 'Fuel' 'Monticello' 'Metacello' 'CodeImport' 'Gofer' 'Configuration' 'RPackage' 'Ring' 'CI' 'GroupManager')
		#('2.0' 'Compatibility' 'Deprecated' 'RecentSubmissions' 'FixUnderscores' 'ScriptLoader20' 'HudsonBuildTools20')
		
	)! !

!AltBrowser class methodsFor: 'instance creation' stamp: 'ThierryGoubier 10/3/2012 16:16'!
fullOnClass: aClass
	"Open on a class."

	| s |
	self rootItems detect: [ :each | (s := each findClass: aClass) notNil ].
	self open selectPathForAbstractItem: s! !

!AltBrowser class methodsFor: 'instance creation' stamp: 'ThierryGoubier 10/3/2012 16:07'!
fullOnClass: aClass selector: aSelector
	"Open on a class."

	| s |
	aSelector isNil ifTrue: [ ^ self fullOnClass: aClass]. 
	self rootItems detect: [ :each | (s := each findMethod: aSelector in: aClass) notNil ].
	self open selectPathForAbstractItem: s! !

!AltBrowser class methodsFor: 'instance creation' stamp: 'ThierryGoubier 10/3/2012 15:35'!
fullOnEnvironment: anEnvironment
" I am not environment aware "
	
	self open! !

!AltBrowser class methodsFor: 'instance creation' stamp: 'ThierryGoubier 10/31/2012 15:29'!
fullOnMethods: aListOfCM
	"Given a list of compiled methods, open, and preselect all of them."
	
	"It's fast, in fact...."

	| s l n |
	n := self open.
	(l := aListOfCM collect: [ :each | each compiledMethod ])
		do: [ :aCompiledMethod | 
			self rootItems
				detect: [ :each | (s := each findMethod: aCompiledMethod selector in: aCompiledMethod methodClass) notNil ].
			n selectPathForAbstractItem: s	" ]
				ifFalse: [ 
					| k |
					n treeModel nodeList
						detect: [ :r | 
							| it |
							(k := r forceFindItem: s) notNil ].
					self assert: k notNil.
					self assert: k class == ABTreeNodeModel.
					n history add: k ]"	"Optimization to store in history without opening" ]! !

!AltBrowser class methodsFor: 'private' stamp: 'ThierryGoubier 11/20/2012 08:21'!
getItemsFor: aCategoryDefinition from: aListOfPackages
	"Remove elements from aListOfPackages to bring them accordingly to a CategoryDefinition. Returns the top-level object. If this definition is an array, go recursively through it."

	"Reduce single element categories to that element."

	aCategoryDefinition isArray
		ifTrue: [ 
			| i |
			i := aCategoryDefinition first -> OrderedCollection new.
			aCategoryDefinition allButFirst do: [ :each | i value add: (self getItemsFor: each from: aListOfPackages) ].
			^ i ]
		ifFalse: [ 
			| i |
			i := aCategoryDefinition -> OrderedCollection new.
			(aListOfPackages
				select: [ :e | 
					e packageName size >= aCategoryDefinition size
						and: [ (e packageName copyFrom: 1 to: aCategoryDefinition size) = aCategoryDefinition ] ])
				do: [ :e | 
					aListOfPackages remove: e.
					i value add: e ].
			i value size == 1
				ifTrue: [ ^ i value first ].
			^ i ]! !

!AltBrowser class methodsFor: 'private' stamp: 'ThierryGoubier 10/3/2012 15:32'!
getRootItems
	"Build the organisation out of some default classification and collect all remaining packages from the list of MCWorkingCopy in the system."

	"There is still some bugs in the packages introduced with the first implementation of RPackage and they show when we build this list."

	| l o |
	l := MCWorkingCopy allManagers asOrderedCollection.
	o := OrderedCollection new.
	self defaultPackageCategoriesNames
		do: [ :w | 
			| i |
			i := self getItemsFor: w from: l.
			o add: i ].
	[ l notEmpty ]
		whileTrue: [ 
			| p w i |
			p := l first.
			w := p packageName copyUpTo: $-.
			i := w -> (OrderedCollection with: p).
			o add: i.
			l remove: p.
			(l select: [ :e | (e packageName copyUpTo: $-) = w ])
				do: [ :e | 
					l remove: e.
					i value add: e ] ].
	^ o
		collect: [ :e | 
			e value size ~= 1
				ifTrue: [ ABPackageCategoryNode with: e ]
				ifFalse: [ ABPackageSetNode with: e value first ] ]! !

!AltBrowser class methodsFor: 'initialization' stamp: 'ThierryGoubier 10/3/2012 15:44'!
initialize
	announcer := Announcer new.
	rootItems := nil.
	self registerOnSystemAnnouncements.
	self registerInAppRegistry
! !

!AltBrowser class methodsFor: 'instance creation' stamp: 'ThierryGoubier 10/3/2012 15:36'!
newOnCategory: aCategory
	"Who is calling that ? Category don't have that much sense anymore."
	
	^ self open! !

!AltBrowser class methodsFor: 'instance creation' stamp: 'ThierryGoubier 10/3/2012 15:36'!
newOnClass: aClass
	^ self fullOnClass: aClass! !

!AltBrowser class methodsFor: 'instance creation' stamp: 'ThierryGoubier 10/3/2012 15:36'!
newOnClass: aClass selector: aSelector
	^ self fullOnClass: aClass selector: aSelector! !

!AltBrowser class methodsFor: 'instance creation' stamp: 'ThierryGoubier 9/25/2012 13:53'!
open
	^ self new open! !

!AltBrowser class methodsFor: 'instance creation' stamp: 'ThierryGoubier 10/3/2012 15:37'!
openMessageList: messageList name: aString autoSelect: aSelector
	" Tool registry compatibility. Disregard the name and consider autoselect as allways true."
	
	"In fact, due to the speed of scanning and opening each path in the tree, this is far too slow. Maybe a solution, but less than adequate, could be to only open path on the very first element, but load the history with the others : this solution works, but is not as good as the direct one. Left in case we find something else."

	^ self fullOnMethods: messageList! !

!AltBrowser class methodsFor: 'initialization' stamp: 'ThierryGoubier 10/3/2012 15:45'!
registerInAppRegistry
	"Register the receiver in the SystemBrowser AppRegistry"

	SystemBrowser register: self! !

!AltBrowser class methodsFor: 'initialization' stamp: 'ThierryGoubier 10/23/2012 13:56'!
registerOnSystemAnnouncements
	"Global registration to update the list."

	"self registerOnSystemAnnouncements."

	SystemAnnouncer uniqueInstance unsubscribe: self.
	SystemAnnouncer uniqueInstance weak
		on: MCWorkingCopyCreated send: #aMCWorkingCopyCreated: to: self;
		on: MCWorkingCopyDeleted send: #aMCWorkingCopyDeleted: to: self;
		on: MCPackageModified send: #aMCWorkingCopyModified: to: self;
		on: CategoryRemoved send: #aCategoryRemoved: to: self;
		on: MethodAdded send: #aMethodAdded: to: self;
		on: MethodRemoved send: #aMethodRemoved: to: self;
		on: MethodRecategorized send: #aMethodRecategorized: to: self;
		on: ClassAdded send: #aClassAdded: to: self;
		on: ClassRemoved send: #aClassRemoved: to: self;
		on: ClassReorganized send: #aClassReorganized: to: self;
		on: ClassCommented send: #aClassCommented: to: self;
		on: ClassRenamed send: #aClassRenamed: to: self;
		on: ClassRepackaged send: #aClassRepackaged: to: self! !

!AltBrowser class methodsFor: 'debug' stamp: 'ThierryGoubier 10/3/2012 15:29'!
removeDebug
	debug := false! !

!AltBrowser class methodsFor: 'accessing' stamp: 'ThierryGoubier 10/3/2012 15:33'!
reset
	"reset the rootItems. Should propagate to all instances as well."
	
	"AltBrowser reset"

	rootItems := self getRootItems.
	announcer announce: AltRootsReset new.! !

!AltBrowser class methodsFor: 'accessing' stamp: 'ThierryGoubier 10/3/2012 16:06'!
rootItems
	rootItems isNil
		ifTrue: [ rootItems := self getRootItems ].
	^ rootItems! !

!AltBrowser class methodsFor: 'debug' stamp: 'ThierryGoubier 10/3/2012 15:29'!
setDebug
	debug := true! !

!AltBrowser class methodsFor: 'user interface' stamp: 'ThierryGoubier 10/3/2012 15:47'!
taskbarIcon
	^ UITheme current smallSystemBrowserIcon! !

!AltBrowser class methodsFor: 'accessing' stamp: 'ThierryGoubier 10/3/2012 15:30'!
temporary
	^ temporary ! !

!AltBrowser class methodsFor: 'accessing' stamp: 'ThierryGoubier 10/3/2012 15:30'!
temporary: aValue
	temporary := aValue! !

!AltBrowser methodsFor: 'updating' stamp: 'ThierryGoubier 9/26/2012 15:32'!
aMethodUpdated: anEvent
	"A method has changed. Check if this is the one we are selecting; if yes, update it."

	| sItem |
	self selectedNode isNil
		ifTrue: [ ^ self ].
	sItem := self selectedNode item.
	self assert: (sItem isKindOf: ABAbstractNode).
	(sItem isKindOf: ABMethodNode)
		ifFalse: [ ^ self ].
	(sItem sourceClass == anEvent methodClass and: [ sItem item == anEvent oldMethod selector ])
		ifTrue: [ source contents: self selectedNode sourceCode ]! !

!AltBrowser methodsFor: 'updating' stamp: 'ThierryGoubier 9/30/2012 18:53'!
aNodeAdded: anEvent
	"Algorithm: look for the parent of the node. If this parent node is found, then add a node equivalent to the contents if they do exist."
	
	"Works, but in a better world, should be handled by an appropriate changed message."
	
	"The findItem: method on MorphTreeNodeMorph may miss part of the opened items; I don't know when. Will have to keep or improve the checkInvariant."

	| pNode aNode |
	aNode := anEvent node.
	(pNode := aNode parentNode) isNil
		ifTrue: [ 
			self assert: (aNode isKindOf: ABTreeNodeModel) not.
			self changed: #rootNodes.
			treeMorph firstNodeMorph checkInvariant ]
		ifFalse: [ 
			treeMorph nodeList
				do: [ :e | 
					| r |
					(r := e findItem: pNode) notNil
						ifTrue: [ 
							| n wNode |
							r rebuildChildren.
							(n := self findMorphNodeForItem: r) notNil
								ifTrue: [ n rebuildChildren ].
							treeMorph firstNodeMorph checkInvariant.
							^ self ] ] ]! !

!AltBrowser methodsFor: 'updating' stamp: 'ThierryGoubier 9/30/2012 22:20'!
aNodeRebuilt: anEvent
	"Similar to others. Search for the node, force a rebuild of the node."

	| r result |
	treeMorph nodeList detect: [ :rootItem | (result := rootItem findItem: anEvent node) notNil ] ifNone: [ ^ self ].
	result notNil
		ifTrue: [ 
			result rebuildContents.
			r := self findMorphNodeForItem: result.
			r notNil
				ifTrue: [ r rebuildChildren ] ]! !

!AltBrowser methodsFor: 'updating' stamp: 'ThierryGoubier 10/23/2012 14:00'!
aNodeRemoved: anEvent
	"Beware : a node is not an instance of ABTreeNodeModel"

	| aNode |
	aNode := anEvent node.
	self assert: aNode isTreeNodeModel not.
	treeMorph nodeList
		do: [ :e | 
			| r |
			(r := e findItem: aNode) notNil
				ifTrue: [ 
					r == e
						ifTrue: [ self changed: #rootNodes ]
						ifFalse: [ 
							| n |
							r parentNode contents remove: r.
							(n := self findMorphNodeForItem: r) notNil
								ifTrue: [ 
									self changed: #deselectAll.
									n rebuildChildren ].
							treeMorph firstNodeMorph checkInvariant ] ] ]! !

!AltBrowser methodsFor: 'updating' stamp: 'ThierryGoubier 11/20/2012 20:45'!
aNodeUpdated: anEvent
	| r result |
	treeMorph nodeList detect: [ :rootItem | (result := rootItem findItem: anEvent node) notNil ] ifNone: [ ^ self ].
	result notNil
		ifTrue: [ 
			r := self findMorphNodeForItem: result.
			r notNil
				ifTrue: [ 
					r submorphs do: [ :e | e delete ].
					r initRow ] ]! !

!AltBrowser methodsFor: 'updating' stamp: 'ThierryGoubier 9/29/2012 10:22'!
aRootsChanged
	"C'est vraiment bourrin, mais a marche, tout en perdant la selection cependant."

	self changed: #deselectAll.
	self changed: #rootNodes! !

!AltBrowser methodsFor: 'drag and drop' stamp: 'ThierryGoubier 10/6/2012 12:45'!
acceptDroppingMorph: aMorph event: evt inMorph: aTreeMorph

	| aTarget |
	aTarget := aTreeMorph scrollerSubMorphFromPoint: evt position.
	self assert: (aTarget  == aTreeMorph potentialDropMorph). 
	aTarget notNil
		ifTrue: [ aTarget complexContents item dropItem: aMorph passenger ]! !

!AltBrowser methodsFor: 'menus' stamp: 'ThierryGoubier 9/25/2012 16:35'!
addModelItemsToWindowMenu: aMenu
	aMenu addLine.
	aMenu add: 'Set debug' target: self class action: #setDebug.
	aMenu add: 'Remove debug' target: self class action: #removeDebug.
	aMenu add: 'Reset' target: self class action: #reset.
	aMenu add: 'Initialize' target: self class action: #initialize! !

!AltBrowser methodsFor: 'menus' stamp: 'ThierryGoubier 9/30/2012 11:34'!
buildTextMenu: aMenu
	self selectedNode notNil
		ifTrue: [ self selectedNode buildTextMenu: aMenu on: textMorph with: self ].
	^ aMenu! !

!AltBrowser methodsFor: 'menus' stamp: 'ThierryGoubier 9/30/2012 11:34'!
buildTreeMenu: aMenu
	"Ask the selection for builidng a menu, otherwise create a default one."

	self selectedNode notNil
		ifTrue: [ self selectedNode item buildTreeMenu: aMenu on: treeMorph with: self ]
		ifFalse: [ 
			| t |
			t := false.
			(Pragma allNamed: #treeAreaCommand from: self class to: self class)
				do: [ :e | 
					t
						ifTrue: [ aMenu addLine ]
						ifFalse: [ t := true ].
					(self perform: e selector) do: [ :c | (c on: treeMorph for: self) addItemToMenu: aMenu ] ] ].
	^ aMenu! !

!AltBrowser methodsFor: 'menus' stamp: 'ThierryGoubier 10/15/2012 14:31'!
defaultCommands
	<treeAreaCommand>
	^ {AltCreatePackageCategoryCommand.
	AltFindClassCommand}! !

!AltBrowser methodsFor: 'user interface' stamp: 'ThierryGoubier 10/6/2012 18:48'!
defaultTreeMorph
	^ super defaultTreeMorph
		doubleClickSelector: #doubleClick;
		nodeStringGetter: #asText;
		getMenuSelector: #buildTreeMenu:;
		dragEnabled: true;
		dropEnabled: true;
		withHLines: false.! !

!AltBrowser methodsFor: 'initialize-release' stamp: 'ThierryGoubier 9/27/2012 19:55'!
delete
	self release! !

!AltBrowser methodsFor: 'drag and drop' stamp: 'ThierryGoubier 10/22/2012 16:45'!
dragPassengerFor: itemMorph inMorph: aTreeMorph
	"Return the morph to be used as a passenger."

	^itemMorph complexContents item! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/30/2012 18:44'!
findMorphNodeForAbstractItem: anItem
	^ treeMorph allNodeMorphs detect: [ :aNodeMorph | aNodeMorph complexContents item == anItem ] ifNone: [ nil ]! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/30/2012 18:47'!
findMorphNodeForItem: anItem
	^ treeMorph allNodeMorphs detect: [ :aNodeMorph | aNodeMorph complexContents == anItem ] ifNone: [ nil ]! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/25/2012 14:12'!
history
	history isNil
		ifTrue: [ 
			history := NavigationHistory new.
			history maxSize: 50 ].
	^ history! !

!AltBrowser methodsFor: 'initialize-release' stamp: 'ThierryGoubier 9/30/2012 22:37'!
initialize
	"Link to the AltBrowser class for most updates."
	
		"Simple, reset everything update."
	self class announcer weak on: AltRootsReset send: #aRootsChanged to: self.
		"Complete, complex and more efficient update handling."
	self class announcer weak on: AltNodeRebuilt send: #aNodeRebuilt: to: self.
	self class announcer weak on: AltNodeRemoved send: #aNodeRemoved: to: self.
	self class announcer weak on: AltNodeAdded send: #aNodeAdded: to: self.
	self class announcer weak on: AltNodeUpdated send: #aNodeUpdated: to: self.
		"Track changes on the method we are editing."
	SystemAnnouncer uniqueInstance weak on: MethodModified send: #aMethodUpdated: to: self! !

!AltBrowser methodsFor: 'user interface' stamp: 'ThierryGoubier 9/30/2012 11:38'!
open
	"Open the window, as simple as that."

	window := self theme newWindowIn: World for: self title: self title.
	treeMorph := self defaultTreeMorph.
	treeMorph buildContents.
	(textMorph := PluggableTextMorph
		on: self source
		text: #contents
		accept: #contents:
		readSelection: nil
		menu: #buildTextMenu:) font: StandardFonts codeFont.
	window addMorph: treeMorph fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 0.3 @ 1) offsets: (0 @ 0 corner: 0 @ 0)).
	window addMorph: textMorph fullFrame: (LayoutFrame fractions: (0.3 @ 0 corner: 1 @ 1) offsets: (0 @ 0 corner: 0 @ 0)).
	window minimumExtent: 500 @ 500.
	window open! !

!AltBrowser methodsFor: 'initialize-release' stamp: 'ThierryGoubier 9/25/2012 14:29'!
release
	self class announcer unsubscribe: self.
	SystemAnnouncer uniqueInstance unsubscribe: self.
	super release! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/27/2012 15:30'!
rootItems
	^ self class rootItems! !

!AltBrowser methodsFor: 'updating' stamp: 'ThierryGoubier 9/25/2012 14:47'!
rootNodeClassFromItem: anItem
	^ ABTreeNodeModel! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 10/15/2012 15:02'!
selectPathForAbstractItem: anItem
	"Stronger than the item version, will force an opening of the ABTreeModelNodes."

	| found aClass nPath tmPath aNode |
	nPath := OrderedCollection new.
	aNode := anItem parentNode.
	[ aNode notNil ]
		whileTrue: [ 
			nPath add: aNode.
			aNode := aNode parentNode ].
	self changed: #(#rootNodes #openItemPath) , nPath reverse.
	treeMorph listManager setSelectedMorph: (self findMorphNodeForAbstractItem: anItem).
	treeMorph
		adjustSubmorphPositions;
		scrollSelectionIntoView	"TODO: move that line into MorphTreeMorph and raise an issue."! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/26/2012 14:42'!
selectedItem
	"Temporary"

	^ self selectedNode! !

!AltBrowser methodsFor: 'updating' stamp: 'ThierryGoubier 10/1/2012 22:06'!
selection: anItem
	"It goes directly here."

	| sel |
	anItem selectedNodePath notNil ifTrue: [sel := anItem selectedNodePath last].
	super selection: anItem.
	self updateTextKeymap.
	self updateTreeKeymap.
	self updateTitle.
	sel isNil
		ifTrue: [ 
			textMorph classOrMetaClass: nil.
			self source aboutToStyle: false.
			self source contents: '' ]
		ifFalse: [
			textMorph classOrMetaClass: sel sourceClass.
			self source aboutToStyle: sel isStyled.
			self source contents: sel sourceCode.
			self history add: sel]! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/25/2012 14:49'!
setRoots: roots
	tree roots: roots! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/26/2012 14:15'!
source
	^ source isNil
		ifTrue: [ 
			source := AltBrowserCodeModel new.
			source browser: self ]
		ifFalse: [ source ]! !

!AltBrowser methodsFor: 'shortcuts' stamp: 'ThierryGoubier 9/25/2012 14:59'!
targetShortcutMorph
	"Get the real, lowest level morph we need to touch the key dispatch for. What a mess!!"

	^ textMorph submorphs first submorphs first! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/25/2012 14:27'!
taskbarIcon
	^ UITheme current smallSystemBrowserIcon! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/25/2012 23:06'!
textModel
	"Temporary"
	
	^ textMorph! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/25/2012 22:56'!
textMorph
	^ textMorph! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/25/2012 14:27'!
title
	self selectedNode notNil
		ifTrue: [ ^ 'Alt: ' , self selectedNode title ]
		ifFalse: [ ^ 'Alt Browser' ]! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/25/2012 23:06'!
treeModel
	"Temporary"

	^ treeMorph! !

!AltBrowser methodsFor: 'accessing' stamp: 'ThierryGoubier 9/25/2012 22:53'!
treeMorph
	^ treeMorph! !

!AltBrowser methodsFor: 'shortcuts' stamp: 'ThierryGoubier 10/1/2012 22:52'!
updateTextKeymap
	"Update the text keymap. Reset the dispatcher and make it an AltKMDispatcher if needed."

	(textMorph kmDispatcher isKindOf: AltKMDispatcher)
		ifFalse: [ textMorph setProperty: #kmdispatcher toValue: (AltKMDispatcher target: textMorph) ].
	(textMorph textMorph kmDispatcher isKindOf: AltKMDispatcher)
		ifFalse: [ textMorph textMorph setProperty: #kmDispatcher toValue: (AltKMDispatcher target:  textMorph textMorph)].
	{(textMorph kmDispatcher).
	(textMorph textMorph kmDispatcher)}
		do: [ :aKMDispatcher | 
			aKMDispatcher reset.
			aKMDispatcher attachCategory: #MorphFocusCtrlNavigation.
			self selectedNode notNil
				ifTrue: [ self selectedNode item buildTextShortcutsOn: aKMDispatcher with: self ] ]! !

!AltBrowser methodsFor: 'shortcuts' stamp: 'ThierryGoubier 9/25/2012 14:57'!
updateTextKeymap: aKMDispatcher
	"Update the text keymap. Reset the dispatcher to avoid the default shortcuts."

	aKMDispatcher reset.
	aKMDispatcher attachCategory: #MorphFocusCtrlNavigation.
	self selectedNode notNil
		ifTrue: [ self selectedNode item buildTextShortcutsOn: aKMDispatcher with: self ]! !

!AltBrowser methodsFor: 'updating' stamp: 'ThierryGoubier 9/25/2012 23:19'!
updateTitle
	window title: self title! !

!AltBrowser methodsFor: 'shortcuts' stamp: 'ThierryGoubier 10/1/2012 22:08'!
updateTreeKeymap
	"Update the tree keymap."

	(treeMorph kmDispatcher isKindOf: AltKMDispatcher)
		ifFalse: [ textMorph setProperty: #kmdispatcher toValue: AltKMDispatcher new ].
	treeMorph kmDispatcher
		reset;
		attachCategory: #MorphFocusNavigation;
		attachCategory: #MorphFocusCtrlNavigation.
	self selectedNode notNil
		ifTrue: [ self selectedNode item buildTreeShortcutsOn: treeMorph kmDispatcher with: self ]
		ifFalse: [ 
			(Pragma allNamed: #treeAreaCommand from: self class to: self class)
				do: [ :e | (self perform: e selector) do: [ :c | (c on: treeMorph for: self) buildShortcut: treeMorph kmDispatcher ] ] ]! !

!AltBrowser methodsFor: 'shortcuts' stamp: 'ThierryGoubier 9/25/2012 22:48'!
updateTreeKeymap: aKMDispatcher
	"Update the tree keymap."

	aKMDispatcher resetPerInstanceTarget.
	self selectedNode notNil
		ifTrue: [ self selectedNode item buildTreeShortcutsOn: aKMDispatcher with: self ]
		ifFalse: [ 
			(Pragma allNamed: #treeAreaCommand from: self class to: self class)
				do: [ :e | (self perform: e selector) do: [ :c | (c on: treeMorph for: self) buildShortcut: aKMDispatcher ] ] ]! !

!AltBrowser methodsFor: 'drag and drop' stamp: 'ThierryGoubier 10/3/2012 16:39'!
wantsDroppedMorph: aMorph event: anEvent inMorph: destMorph
	"TODO: Filter out to avoid drag and drop of different objet types. Here, we don't know what the target may be so filtering is limited."

	^ destMorph == treeMorph! !

TestCase subclass: #AltBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Tests'!

!AltBrowserTest commentStamp: '<historical>' prior: 0!
Testing for the AltBrowser is here.!

!AltBrowserTest methodsFor: 'tests' stamp: 'ThierryGoubier 10/17/2012 15:58'!
testRootItems
	self assert: (AltBrowser getRootItems notEmpty)! !

!AltBrowserTest methodsFor: 'tests' stamp: 'ThierryGoubier 10/17/2012 15:58'!
testSpawn2RootItems
	AltBrowser getRootItems do: [:e | e contents do: [:f | f contents]]! !

!AltBrowserTest methodsFor: 'tests' stamp: 'ThierryGoubier 10/17/2012 15:58'!
testSpawn3RootItems
	AltBrowser getRootItems do: [ :e | e contents do: [ :f | f contents do: [ :g | g contents ] ] ]! !

!AltBrowserTest methodsFor: 'tests' stamp: 'ThierryGoubier 10/17/2012 15:58'!
testSpawnRootItems
	AltBrowser getRootItems do: [:e | e contents]! !

!IndentingListItemMorph methodsFor: '*alt-browser' stamp: 'ThierryGoubier 9/9/2012 15:07'!
checkInvariant
	"Check that this morph is correct regarding it's abstract contents."

	"We check that siblings are correctly aligned and have the right index."

	self
		withSiblingsDo: [ :each | 
			each assert: (each firstChild isNil or: [ each complexContents contents notNil ]).
			each complexContents item parentNode notNil
				ifTrue: [ 
					each
						assert:
							((each nextSibling isNil and: [ each complexContents item = each complexContents item parentNode contents last ])
								or: [ each nextSibling notNil ]).
					each nextSibling notNil
						ifTrue: [ 
							each
								assert:
									((each complexContents item parentNode contents indexOf: each complexContents item) + 1
										= (each nextSibling complexContents item parentNode contents indexOf: each nextSibling complexContents item)
										and: [ each complexContents item parentNode == each nextSibling complexContents item parentNode ]) ] ] ].
	self
		withSiblingsDo: [ :each | 
			each firstChild notNil
				ifTrue: [ each firstChild checkInvariant ] ]! !

!IndentingListItemMorph methodsFor: '*Alt-Browser' stamp: 'ThierryGoubier 9/9/2012 23:19'!
findExpanded
	"Get all expanded items among children recursively."

	| currentlyExpanded |
	currentlyExpanded := OrderedCollection new.
	firstChild notNil
		ifTrue: [ firstChild withSiblingsDo: [ :aNode | currentlyExpanded addAll: aNode findExpanded ] ].
	self isExpanded
		ifTrue: [ currentlyExpanded add: self ].
	^ currentlyExpanded! !

!IndentingListItemMorph methodsFor: '*alt-browser' stamp: 'ThierryGoubier 9/27/2012 21:58'!
findItem: aNode
	"Hierarchical search"
	
	| found |
	self
		withSiblingsDo: [ :each | 
			each complexContents item == aNode
				ifTrue: [ ^ each ] ].
	self
		withSiblingsDo: [ :each | 
			each firstChild notNil
				ifTrue: [ 
					found := each firstChild findItem: aNode.
					found notNil
						ifTrue: [ ^ found ] ] ].
	^ nil! !

!IndentingListItemMorph methodsFor: '*alt-browser' stamp: 'ThierryGoubier 9/18/2012 13:59'!
rebuildChildren
	"Force a rebuild of the childrens. May be triggered by going from no children to has children."

	self recursiveRefreshExpandedState.
	container adjustSubmorphPositions! !

!IndentingListItemMorph methodsFor: '*Alt-Browser' stamp: 'ThierryGoubier 9/9/2012 23:19'!
recursiveRefreshExpandedState
	"Trying to do a better refreshExpandedState which remembers expanded children."

	| toDelete c final currentlyExpanded |
	toDelete := OrderedCollection new.
	currentlyExpanded := OrderedCollection new.
	firstChild
		ifNotNil: [ 
			firstChild
				withSiblingsDo: [ :aNode | 
					currentlyExpanded addAll: aNode findExpanded.
					aNode recursiveAddTo: toDelete ] ].
	container noteRemovalOfAll: toDelete.
	(isExpanded and: [ complexContents hasContents ])
		ifFalse: [ ^ self changed ].
	(c := complexContents contents) isEmpty
		ifTrue: [ ^ self changed ].
	final := OrderedCollection new.
	self addChildrenForList: container addingTo: final withExpandedItems: currentlyExpanded.
	container scroller addAllMorphs: final after: self! !

!MorphTreeNodeMorph methodsFor: '*Alt-Browser' stamp: 'ThierryGoubier 9/30/2012 08:46'!
checkInvariant
	"Check that this morph is correct regarding it's abstract contents."

	"We check that siblings are correctly aligned and have the right index."

	self
		withSiblingsDo: [ :each | 
			each assert: (each firstChild isNil or: [ each complexContents contents notNil ]).
			each complexContents item parentNode notNil
				ifTrue: [ 
					each
						assert:
							((each nextSibling isNil and: [ each complexContents item = each complexContents item parentNode contents last ])
								or: [ each nextSibling notNil ]).
					each nextSibling notNil
						ifTrue: [ 
							each
								assert:
									((each complexContents item parentNode contents indexOf: each complexContents item) + 1
										= (each nextSibling complexContents item parentNode contents indexOf: each nextSibling complexContents item)
										and: [ each complexContents item parentNode == each nextSibling complexContents item parentNode ]) ] ] ].
	self
		withSiblingsDo: [ :each | 
			each firstChild notNil
				ifTrue: [ each firstChild checkInvariant ] ]! !

!MorphTreeNodeMorph methodsFor: '*Alt-Browser' stamp: 'ThierryGoubier 9/27/2012 23:39'!
findExpanded
	"Get all expanded items among children recursively."

	| currentlyExpanded |
	currentlyExpanded := OrderedCollection new.
	firstChild notNil
		ifTrue: [ firstChild withSiblingsDo: [ :aNode | currentlyExpanded addAll: aNode findExpanded ] ].
	self isExpanded
		ifTrue: [ currentlyExpanded add: self ].
	^ currentlyExpanded! !

!MorphTreeNodeMorph methodsFor: '*Alt-Browser' stamp: 'ThierryGoubier 9/30/2012 09:41'!
findItem: aNode
	"Search for a complex contents item."

	| found |
	self
		withSiblingsDo: [ :each | 
			each complexContents item == aNode
				ifTrue: [ ^ each ] ].
	self
		withSiblingsDo: [ :each | 
			each firstChild notNil
				ifTrue: [ 
					found := each firstChild findItem: aNode.
					found notNil
						ifTrue: [ ^ found ] ] ].
	^ nil! !

!MorphTreeNodeMorph methodsFor: '*Alt-Browser' stamp: 'ThierryGoubier 9/27/2012 21:59'!
rebuildChildren
	"Force a rebuild of the childrens. May be triggered by going from no children to has children."

	self recursiveRefreshExpandedState.
	container adjustSubmorphPositions! !

!MorphTreeNodeMorph methodsFor: '*Alt-Browser' stamp: 'ThierryGoubier 9/27/2012 21:59'!
recursiveRefreshExpandedState
	"Trying to do a better refreshExpandedState which remembers expanded children."

	| toDelete c final currentlyExpanded |
	toDelete := OrderedCollection new.
	currentlyExpanded := OrderedCollection new.
	firstChild
		ifNotNil: [ 
			firstChild
				withSiblingsDo: [ :aNode | 
					currentlyExpanded addAll: aNode findExpanded.
					aNode recursiveAddTo: toDelete ] ].
	container noteRemovalOfAll: toDelete.
	(isExpanded and: [ complexContents hasContents ])
		ifFalse: [ ^ self changed ].
	(c := complexContents contents) isEmpty
		ifTrue: [ ^ self changed ].
	final := OrderedCollection new.
	self addChildrenForList: container addingTo: final withExpandedItems: currentlyExpanded.
	container scroller addAllMorphs: final after: self! !

Object subclass: #ABAbstractNode
	instanceVariableNames: 'item contents parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABAbstractNode commentStamp: '<historical>' prior: 0!
An ABAbstractNode is the abstract type of all nodes used by the AltBrowser.!

!ABAbstractNode class methodsFor: 'instance creation' stamp: 'ThierryGoubier 7/19/2012 22:36'!
with: anItem
	^ self new item: anItem! !

!ABAbstractNode methodsFor: 'actions' stamp: 'ThierryGoubier 9/9/2012 15:06'!
accept: aText notifying: aController
	"When the text editor associated has accepted, do that..."

	"That is, nothing by default."
	
	^ nil

	! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/3/2012 18:18'!
addChild: anItem
	"Add a child, but do it according to it's position."

	| d newItemNode |
	d := self childrenItems indexOf: anItem.
	contents add: (newItemNode := self childNodeFromItem: anItem) beforeIndex: d.
	^ newItemNode! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 8/30/2012 00:00'!
addChildItem: anItem
	"Add a child item. Remember to effectively add both at the item level if necessary and at the contents level."

	| d |
	self childrenItems isEmpty ifTrue: [^self contents add: anItem].
	d := self childrenItems indexOf: anItem item.
	^ contents add: anItem beforeIndex: d! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 21:38'!
addChildItem: anItem beforeIndex: index
	"Add a child, but do it according to it's position."

	anItem parentNode: self.
	^ contents add: anItem beforeIndex: index! !

!ABAbstractNode methodsFor: 'printing' stamp: 'ThierryGoubier 7/19/2012 22:43'!
asString
	^ item asString! !

!ABAbstractNode methodsFor: 'printing' stamp: 'ThierryGoubier 9/18/2012 13:16'!
asText
	^ self asString! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 11/17/2012 08:15'!
buildTextMenu: aMenu on: aTarget with: aRequestor
	"Now I have a safe way of finding pragmas."

	| t |
	t := false.
	(self pragmas: #textAreaCommand from: self class to: ABAbstractNode)
		do: [ :p | 
			t
				ifTrue: [ aMenu addLine ]
				ifFalse: [ t := true ].
			(self perform: p selector) do: [ :c | (c on: aTarget for: aRequestor) addItemToMenu: aMenu ] ]! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 11/17/2012 08:18'!
buildTextShortcutsOn: aKMDispatcher with: aRequestor
	"This is an attempt at handling shortcuts... Which works, with the help of a custom KMDispatcher."

	(self pragmas: #textAreaCommand from: self class to: ABAbstractNode)
		do: [ :e | 
			(self perform: e selector)
				do: [ :c | 
					| command |
					command := c on: aRequestor textModel for: aRequestor.
					command buildShortcut: aKMDispatcher ] ]! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 11/18/2012 01:25'!
buildTreeMenu: aMenu on: aTarget with: aRequestor
	| t |
	t := false.
	(self pragmas: #treeAreaCommand from: self class to: ABAbstractNode)
		do: [ :e | 
			t
				ifTrue: [ aMenu addLine ]
				ifFalse: [ t := true ].
			(self perform: e selector) do: [ :c | (c on: aTarget for: aRequestor) addItemToMenu: aMenu ] ]! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 11/18/2012 01:25'!
buildTreeShortcutsOn: aMorph with: aRequestor
	"This is an attempt at handling shortcuts... Which works, with the help of a custom KMDispatcher."

	(self pragmas: #treeAreaCommand from: self class to: ABAbstractNode)
		do: [ :e | 
			(self perform: e selector)
				do: [ :c | 
					| command |
					command := c on: aRequestor treeModel for: aRequestor.
					command isEnabled
						ifTrue: [ command buildShortcut: aMorph ] ] ]! !

!ABAbstractNode methodsFor: 'private' stamp: 'ThierryGoubier 7/19/2012 22:32'!
childNodeClassFromItem: anItem
	^ self class! !

!ABAbstractNode methodsFor: 'private' stamp: 'ThierryGoubier 7/27/2012 21:34'!
childNodeFromItem: anItem
	^ ((self childNodeClassFromItem: anItem) with: anItem)
		parentNode: self;
		yourself! !

!ABAbstractNode methodsFor: 'private' stamp: 'ThierryGoubier 7/19/2012 22:34'!
childrenItems
	^ #()! !

!ABAbstractNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 15:10'!
clipboardCommands
	<textAreaCommand>
	^ {AltCutTextCommand.
	AltCopyTextCommand.
	AltPasteTextCommand}! !

!ABAbstractNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 15:11'!
clipboardTreeCommands
	<treeAreaCommand>
	^ {AltCutCommand.
		AltPasteCommand}! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/3/2012 18:16'!
contents
	contents isNil
		ifTrue: [ contents := (self childrenItems collect: [ :i | self childNodeFromItem: i ]) asOrderedCollection ].
	^ contents! !

!ABAbstractNode methodsFor: 'testing' stamp: 'ThierryGoubier 7/27/2012 21:47'!
contentsNotNil
	^ contents notNil! !

!ABAbstractNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 14:55'!
debugTreeCommands
	<treeAreaCommand>
	^ {AltExploreItemCommand. AltRebuildItemCommand }! !

!ABAbstractNode methodsFor: 'drag and drop' stamp: 'ThierryGoubier 9/9/2012 23:33'!
dropItem: anItem
	"By default, do nothing."
	
	^ nil! !

!ABAbstractNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 14:56'!
executeCommands
	<textAreaCommand>
	^ {AltDoItTextCommand.
	AltPrintItTextCommand.
	AltInspectItTextCommand.
	AltExploreItTextCommand.
	AltDebugItTextCommand}! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 10:08'!
findAllClass: aClass
	"Return the node if the item matches. By default, search among the kids."
	
	"Make it lazy : do not trigger contents generation."

	| o res |
	contents notNil
		ifTrue: [ 
			self contents
				do: [ :each | 
					(res := each findAllClass: aClass) notNil
						ifTrue: [ 
							o isNil
								ifTrue: [ o := res ]
								ifFalse: [ o addAll: res ] ] ] ].
	^ o! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 10:09'!
findAllMethodParents: aMethodSelector forClass: aClass
	"Return all nodes if the item matches. By default, search among the kids. Is lazy and will avoid triggering child building."

	"Make it lazy : do not trigger contents generation."

	| o res |
	contents notNil
		ifTrue: [ 
			self contents
				do: [ :each | 
					(res := each findAllMethodParents: aMethodSelector forClass: aClass) notNil
						ifTrue: [ 
							o isNil
								ifTrue: [ o := res ]
								ifFalse: [ o addAll: res ] ] ] ].
	^ o! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 18:03'!
findClass: aClass
	"Return the node if the item matches. By default, search among the kids."

	"Not lazy : force contents generation."

	| found res |
	self contents
		do: [ :each | 
			(res := each findClass: aClass) notNil
				ifTrue: [ found := res ] ].
	^ found! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 10:10'!
findClassCategory: aCat
	"Return the node if the item matches. By default, search among the kids. Is lazy and will avoid triggering child building."

	"Make it lazy : do not trigger contents generation."

	| res |
	contents notNil
		ifTrue: [ 
			self contents
				do: [ :each | 
					(res := each findClassCategory: aCat) notNil
						ifTrue: [ ^ res ] ] ].
	^ nil! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 10:11'!
findClassComment: aClass
	"Return the node if the item matches. By default, search among the kids. Is lazy and will avoid triggering child building."
	
	"Make it lazy : do not trigger contents generation."

	| res |
	contents notNil
		ifTrue: [ 
			self contents
				do: [ :each | 
					(res := each findClassComment: aClass) notNil
						ifTrue: [ ^ res ] ] ].
	^ nil! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 10:11'!
findMethod: aSelector in: aClass
	"Return the node if the item matches. By default, search among the kids."

	"Make it lazy : do not trigger contents generation."

	| res |
	contents notNil
		ifTrue: [ 
			self contents
				do: [ :each | 
					(res := each findMethod: aSelector in: aClass) notNil
						ifTrue: [ ^ res ] ] ].
	^ nil! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 10:12'!
findMethodCategory: aMethodCategory in: aClass
	"Return the node if the item matches. By default, search among the kids. Is lazy and will avoid triggering child building."

	"Make it lazy : do not trigger contents generation."

	| res |
	contents notNil
		ifTrue: [ 
			self contents
				do: [ :each | 
					(res := each findMethodCategory: aMethodCategory in: aClass) notNil
						ifTrue: [ ^ res ] ] ].
	^ nil! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 22:57'!
findPackage: aRPackage
	"Return the node if the item matches. By default, search among the kids. Is lazy and will avoid triggering child building."

	"Not lazy : triggers contents generation."

	| res |
	self contents
		do: [ :each | 
			(res := each findPackage: aRPackage) notNil
				ifTrue: [ ^ res ] ].
	^ nil! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 18:04'!
findPackageSet: aRPackageSetOrMCWCOrMCPackage
	"Return the node if the item matches. By default, search among the kids."

	| res |
	self contents
		do: [ :each | 
			(res := each findPackageSet: aRPackageSetOrMCWCOrMCPackage) notNil
				ifTrue: [ ^ res ] ].
	^ nil! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/30/2012 14:01'!
indexOfChild: anItem
	^ self childrenItems indexOf: anItem! !

!ABAbstractNode methodsFor: 'testing' stamp: 'ThierryGoubier 7/19/2012 23:20'!
isStyled
	"Should return true if the text is to be styled (default smalltalk code)."
	
	^ false! !

!ABAbstractNode methodsFor: 'testing' stamp: 'ThierryGoubier 7/31/2012 14:44'!
isTreeNodeModel
	^ false! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/19/2012 22:36'!
item
	^ item! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/19/2012 22:36'!
item: anObject
	item := anObject! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/19/2012 22:36'!
parentNode
	^ parentNode! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/19/2012 22:36'!
parentNode: anObject
	parentNode := anObject! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 11/17/2012 08:11'!
pragmas: aSymbol from: aClass to: aTarget
	"A safe way to find pragmas in a class hierarchy."

	| pragmas |
	pragmas := OrderedCollection new.
	(aClass allSelectorsBelow: aTarget superclass)
		do: [ :selector | 
			(aClass lookupSelector: selector) pragmas
				do: [ :pragma | 
					pragma key == aSymbol
						ifTrue: [ pragmas add: pragma ] ] ].
	^ pragmas! !

!ABAbstractNode methodsFor: 'printing' stamp: 'ThierryGoubier 8/30/2012 07:04'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self asString.
	aStream nextPut: $)! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/18/2012 14:14'!
rebuildContents
	"Force a rebuild of the contents, to either : change the layout of the children items, or just because the contents has become out of sync with the children items."

	"Optimize that to reuse existing objects as much as possible."

	contents notNil
		ifTrue: [ 
			contents := (self childrenItems
				collect: [ :i | 
					| n |
					n := contents detect: [ :e | e item == i ] ifNone: [ nil ].
					n isNil
						ifTrue: [ self childNodeFromItem: i ]
						ifFalse: [ n ] ]) asOrderedCollection ]! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/3/2012 18:17'!
removeChildItem: anItem
	"Remove a child item. Some subclasses may do things with the item, or translate this into an operation."

	self contents remove: anItem! !

!ABAbstractNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 14:30'!
saveCommands
	<textAreaCommand>
	^ {AltAcceptTextCommand.
	AltCancelTextCommand}! !

!ABAbstractNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 15:03'!
searchTreeCommands
	<treeAreaCommand>
	^ {AltFindClassCommand. AltPreviousCommand. AltNextCommand }! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/19/2012 23:20'!
sourceClass
	"Should return a class if appropriate. The class is to provide the context for compilation, evaluation or styling."

	^ nil! !

!ABAbstractNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/19/2012 23:19'!
sourceCode
	"Should return a source code or a description if appropriate."
	
	^ ''! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/21/2012 16:12'!
title
	^ ''! !

!ABAbstractNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 14:53'!
undoCommands
	<textAreaCommand>
	^ {AltUndoTextCommand.
	AltRedoTextCommand}! !

ABAbstractNode subclass: #ABClassCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABClassCategoryNode commentStamp: '<historical>' prior: 0!
An ABClassCategoryNode is for class categories.
!

!ABClassCategoryNode class methodsFor: 'ordering' stamp: 'ThierryGoubier 9/11/2012 17:12'!
orderClasses: aClassList
	"Order classes according to their superclasses."

	| r addClassBlock c |
	addClassBlock := [ :fromList :toList :aClass | 
	(toList includes: aClass)
		ifFalse: [ 
			(fromList includes: aClass superclass)
				ifTrue: [ 
					(toList includes: aClass superclass)
						ifFalse: [ addClassBlock value: fromList value: toList value: aClass superclass ].
					toList add: aClass afterIndex: (toList indexOf: aClass superclass) ]
				ifFalse: [ toList addFirst: aClass ] ] ].
	r := OrderedCollection new.
	c := SortedCollection sortBlock: [:a :b | a name > b name].
	c addAll: aClassList.
	c do: [ :eachClass | addClassBlock value: aClassList value: r value: eachClass ].
	^ r! !

!ABClassCategoryNode methodsFor: 'private' stamp: 'ThierryGoubier 7/31/2012 22:28'!
childNodeClassFromItem: anItem
	(anItem isBehavior or: [ anItem isTrait ])
		ifTrue: [ ^ ABClassNode ]
		ifFalse: [ ^ self class ]! !

!ABClassCategoryNode methodsFor: 'private' stamp: 'ThierryGoubier 9/10/2012 13:24'!
childrenItems
	"Extract from the organisation the various classes. Ok. Our upper level should try to built a hierarchy with the category name, if applicable (via various upTo: $-). This code is ready for that (introduce an additional hierarchy)."

	"We use Smalltalk organisation for that, not Rpackage stuff, and they may diverge (they do)."

	| c o r addClassBlock |
	c := Smalltalk organization categoriesMatching: self item.
	c size > 2
		ifTrue: [ ^ c ]
		ifFalse: [ ^ self class orderClasses: (Smalltalk organization classesInCategory: c first) ]! !

!ABClassCategoryNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/27/2012 10:25'!
findClassCategory: aCat
	"Return the node if the item matches. By default, search among the kids. Is lazy and will avoid triggering child building."

	item == aCat
		ifTrue: [ ^ self ]
		ifFalse: [ ^ nil ]! !

ABAbstractNode subclass: #ABClassCommentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABClassCommentNode commentStamp: '<historical>' prior: 0!
An ABClassCommentNode is for a class comment, if any. No children.
!

!ABClassCommentNode methodsFor: 'actions' stamp: 'ThierryGoubier 11/21/2012 13:38'!
accept: aText notifying: aController
	"This should change the class comment"
	
	"I have a problem there: the Class comment node is recreated on update and therefore the system loses the focus."

	self item comment: aText.
	^ self! !

!ABClassCommentNode methodsFor: 'printing' stamp: 'ThierryGoubier 9/18/2012 13:17'!
asString
	^  'comment'! !

!ABClassCommentNode methodsFor: 'printing' stamp: 'ThierryGoubier 9/26/2012 15:40'!
asText
	^ self item hasComment
		ifTrue: [ 'comment' ]
		ifFalse: [ '!!comment' ]! !

!ABClassCommentNode methodsFor: 'drag and drop' stamp: 'ThierryGoubier 10/3/2012 22:18'!
dropItem: anItem
	"Only valid for an ABMethodCategoryNode. This is because the comment is at the beginning of the list of protocols, so allows for moving a protocol at the beginning of the list."

	| oldCategories newCategories |
	((anItem isKindOf: ABMethodCategoryNode) and: [ anItem sourceClass == self item ])
		ifFalse: [ ^ self ].
	oldCategories := self item organization categories copy.
	newCategories := {anItem item} , (oldCategories copyWithout: anItem item).
	SystemAnnouncer uniqueInstance
		suspendAllWhile: [ self item organization categories: newCategories asArray ].
	self item organization notifyOfChangedCategoriesFrom: oldCategories to: self item organization categories! !

!ABClassCommentNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/27/2012 14:30'!
findClassComment: aClass
	^ item == aClass
		ifTrue: [ self ]
		ifFalse: [ nil ]! !

!ABClassCommentNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/16/2012 20:36'!
sourceCode
	^ self item comment! !

ABAbstractNode subclass: #ABClassNode
	instanceVariableNames: 'indent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABClassNode commentStamp: '<historical>' prior: 0!
An ABClassNode represent a class!

ABClassNode subclass: #ABClassExtensionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABClassExtensionNode commentStamp: '<historical>' prior: 0!
An ABClassExtensionNode is used when browsing the extension of a package. Restrict itself to the methods of the extension of the parent package.!

!ABClassExtensionNode methodsFor: 'actions' stamp: 'ThierryGoubier 9/30/2012 08:46'!
accept: aText notifying: aController
	"Compile the method. Return a target methodNode object for the method. We know it should be one of our children."

	| aSelector aMethodNode |
	aSelector := self sourceClass compile: aText classified: self methodCategory notifying: aController.	"New node should have been added in there."
	self rebuildContents.
	aMethodNode := self parentNode findMethod: aSelector in: self sourceClass.
	^ aMethodNode! !

!ABClassExtensionNode methodsFor: 'printing' stamp: 'ThierryGoubier 7/17/2012 13:37'!
asString
	^ self item asString! !

!ABClassExtensionNode methodsFor: 'private' stamp: 'ThierryGoubier 7/17/2012 13:39'!
childNodeClassFromItem: anItem
	^ ABMethodNode! !

!ABClassExtensionNode methodsFor: 'private' stamp: 'ThierryGoubier 8/27/2012 00:19'!
childrenItems
	^ ((self parentNode item extensionMethodsForClass: self item) collect: [ :e | e selector ])
		asSortedCollection! !

!ABClassExtensionNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 9/20/2012 22:03'!
findAllMethodParents: aMethodSelector forClass: aClass
	"Ask the package to know if this method is an extension. Ok, this may work, but only if the class has already extension methods. Is short-circuited by PackageExtensionNode."
	
	^ (item == aClass and: [ parentNode item includesExtensionSelector: aMethodSelector ofClass:  item])
		ifTrue: [ OrderedCollection with: self parentNode ]
		ifFalse: [ nil ]! !

!ABClassExtensionNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/1/2012 00:28'!
findClass: aClass
	"When we are looking for a class, we fail the test in that class extension."

	^ nil! !

!ABClassExtensionNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/20/2012 22:17'!
findMethodCategory: aCategory in: aClass
	"As an extension, we are a protocol (or multiple ones, in fact). Return the parent node, it's safer when the class loses its last extension selector (it's a bit of a hack, really."

	^ (item == aClass and: [ parentNode item isYourClassExtension: aCategory ])
		ifTrue: [ 
			self childrenItems isEmpty
				ifTrue: [ self parentNode ]
				ifFalse: [ self ] ]
		ifFalse: [ nil ]! !

!ABClassExtensionNode methodsFor: 'accessing' stamp: 'ThierryGoubier 8/28/2012 17:28'!
methodCategory
	"Still working in fact."
	
	^ parentNode item methodCategoryPrefix! !

!ABClassExtensionNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/31/2012 21:58'!
sourceClass
	^ self item! !

!ABClassExtensionNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/31/2012 22:08'!
sourceCode
	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!ABClassNode methodsFor: 'actions' stamp: 'ThierryGoubier 10/23/2012 14:05'!
accept: aText notifying: aController
	| res |
	res := [ 
	UndefinedObject evaluatorClass new
		evaluate: (ReadStream on: aText)
		in: nil
		to: nil
		notifying: aController
		ifFail: [ ^ nil ]
		logged: true ]
		on: OutOfScopeNotification
		do: [ :ex | ex resume: true ].
	res notNil
		ifTrue: [ 
			| r |
			AltBrowser rootItems detect: [ :aRoot | (r := aRoot findClass: res) notNil] ifNone: [nil].
			^ r ].
	^ nil! !

!ABClassNode methodsFor: 'printing' stamp: 'ThierryGoubier 9/10/2012 13:14'!
asString
	^ self item isMeta
		ifTrue: [ '- Class' ]
		ifFalse: [ (String new: self indent withAll: Character space) , self item asString ]! !

!ABClassNode methodsFor: 'private' stamp: 'ThierryGoubier 7/16/2012 20:07'!
childNodeClassFromItem: anItem
	anItem == self item classSide
		ifTrue: [ ^ self class ].
	anItem == self item
		ifTrue: [ ^ ABClassCommentNode ].
	^ ABMethodCategoryNode! !

!ABClassNode methodsFor: 'private' stamp: 'ThierryGoubier 7/16/2012 20:06'!
childrenItems
	^ self item isMeta
		ifFalse: [ 
			{(self item classSide).
			(self item)} , self item organization categories ]
		ifTrue: [ self item organization categories ]! !

!ABClassNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 14:30'!
classSearchCommands
	<treeAreaCommand>
	^ {AltClassRefsCommand}! !

!ABClassNode methodsFor: 'private' stamp: 'ThierryGoubier 7/16/2012 13:56'!
classSide
	^ self item isMeta
		ifFalse: [ {(self item classSide)} ]
		ifTrue: [ {} ]! !

!ABClassNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/3/2012 17:45'!
contentsOrganization
	"Answer the organization of that object. This is the cached one (as probably displayed), maybe not the real one."

	^ Array
		withAll:
			((self item isMeta
				ifTrue: [ self contents ]
				ifFalse: [ self contents allButFirst: 2 ]) collect: [ :c | c item ])! !

!ABClassNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/1/2012 18:38'!
findAllClass: aClass
	^ self item == aClass
		ifTrue: [ OrderedCollection with: self ]
		ifFalse: [ super findAllClass: aClass ]! !

!ABClassNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/1/2012 18:38'!
findClass: aClass
	^ self item == aClass
		ifTrue: [ self ]
		ifFalse: [ super findClass: aClass ]! !

!ABClassNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 10:18'!
findMethod: aSelector in: aClass
	"Ok. Forced version. May need to force on a case by case basis."

	| res |
	self item isMeta
		ifTrue: [ 
			aClass == item
				ifTrue: [ 
					self contents
						do: [ :each | 
							(res := each findMethod: aSelector in: aClass) notNil
								ifTrue: [ ^ res ]] ] ]
		ifFalse: [ 
			aClass == item
				ifTrue: [ 
					self contents
						do: [ :each | 
							(res := each findMethod: aSelector in: aClass) notNil
								ifTrue: [ ^ res ] ] ]
				ifFalse: [ ^ self contents first findMethod: aSelector in: aClass ] ].
	^ nil! !

!ABClassNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/10/2012 13:16'!
indent
	indent isNil
		ifTrue: [ 
			| i |
			(i := self parentNode contents detect: [ :e | e item == self item superclass ] ifNone: [ nil ]) notNil
				ifTrue: [ indent := i indent + 1 ]
				ifFalse: [ indent := 0 ] ].
	^ indent! !

!ABClassNode methodsFor: 'testing' stamp: 'ThierryGoubier 7/19/2012 23:23'!
isStyled
	^ true! !

!ABClassNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 15:11'!
navigationCommands
	<treeAreaCommand>
	^ {AltGoToSuperclassCommand.
	AltGoToSubclassCommand.
	AltNextSiblingClassCommand}! !

!ABClassNode methodsFor: 'private' stamp: 'ThierryGoubier 7/17/2012 13:54'!
privateClass
	^ self item! !

!ABClassNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/10/2012 13:57'!
refactoringCommands
	<treeAreaCommand>
	
	^ { AltRBUndoCommand. AltRBRedoCommand. AltRBClassRenameCommand }! !

!ABClassNode methodsFor: 'commands' stamp: 'ThierryGoubier 11/16/2012 23:10'!
removeClassCommand
	<treeAreaCommand>
	^ {AltRemoveClassCommand}! !

!ABClassNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/16/2012 14:18'!
sourceCode
	^ self item definition! !

!ABClassNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/26/2012 11:29'!
subclasses
	^ item subclasses! !

!ABClassNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/26/2012 11:30'!
superclass
	^ item superclass! !

!ABClassNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/21/2012 16:18'!
title
	^ item name! !

ABAbstractNode subclass: #ABMethodCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABMethodCategoryNode commentStamp: '<historical>' prior: 0!
For a method category. No need for an -- all ---, the tree list allow for opening everything if needed. The 'as yet unclassified' method category (protocol) is managed on the fly (and exist in the system) !

!ABMethodCategoryNode methodsFor: 'actions' stamp: 'ThierryGoubier 9/22/2012 11:58'!
accept: aText notifying: aController
	"Compile the method. Return a target methodNode object for the method. We know it should be one of our children."

	| aSelector aMethodNode |
	aSelector := self sourceClass compile: aText classified: self methodCategory notifying: aController.	"New node should have been added in there."
	self rebuildContents.
	aMethodNode := self parentNode findMethod: aSelector in: self sourceClass.
	^ aMethodNode! !

!ABMethodCategoryNode methodsFor: 'private' stamp: 'ThierryGoubier 7/16/2012 00:18'!
childNodeClassFromItem: anItem
	^ ABMethodNode! !

!ABMethodCategoryNode methodsFor: 'private' stamp: 'ThierryGoubier 7/27/2012 16:25'!
childrenItems
	^ (self parentNode item methodsInCategory: self item) asSortedCollection! !

!ABMethodCategoryNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/3/2012 17:39'!
contentsOrganization
	^ self item -> self childrenItems! !

!ABMethodCategoryNode methodsFor: 'drag and drop' stamp: 'ThierryGoubier 10/22/2012 15:36'!
dropItem: anItem
	"Only valid for an ABMethodCategoryNode or an ABMethodNode."

	((anItem isKindOf: ABMethodCategoryNode) or: [ anItem isKindOf: ABMethodNode ])
		ifFalse: [ ^ self ].
	anItem sourceClass == self sourceClass
		ifFalse: [ ^ self ].
	anItem == self
		ifTrue: [ ^ self ].
	(anItem isKindOf: ABMethodNode)
		ifTrue: [ 
			| cm |
			cm := anItem compiledMethod.
			cm methodClass organization classify: anItem item under: self item suppressIfDefault: false ].
	(anItem isKindOf: ABMethodCategoryNode)
		ifTrue: [ 
			| oldCategories newCategories |
			oldCategories := self sourceClass organization categories copy.
			newCategories := (oldCategories copyWithout: anItem item) asOrderedCollection.
			newCategories add: anItem item after: self item.
			SystemAnnouncer uniqueInstance suspendAllWhile: [ self sourceClass organization categories: newCategories asArray ].
			self sourceClass organization notifyOfChangedCategoriesFrom: oldCategories to: self sourceClass organization categories ]! !

!ABMethodCategoryNode methodsFor: 'querying' stamp: 'ThierryGoubier 8/29/2012 11:21'!
findAllMethodParents: aMethodSelector forClass: aClass
	^ (parentNode item == aClass and: [ (parentNode item whichCategoryIncludesSelector: aMethodSelector) = item ])
		ifTrue: [ OrderedCollection with: self ]
		ifFalse: [ nil ]! !

!ABMethodCategoryNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 17:09'!
findMethod: aSelector in: aClass
	self sourceClass == aClass
		ifTrue: [ 
			self contents
				do: [ :each | 
					| res |
					(res := each findMethod: aSelector in: aClass) notNil
						ifTrue: [ ^ res ] ] ].
	^ nil! !

!ABMethodCategoryNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/6/2012 22:36'!
findMethodCategory: aMethodCategory in: aClass
	^ (aMethodCategory = item and: [ aClass == parentNode item ])
		ifTrue: [ self ]
		ifFalse: [ nil ]! !

!ABMethodCategoryNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/10/2012 19:29'!
formatCommand
	<textAreaCommand>
	^ {AltRBFormatCommand}! !

!ABMethodCategoryNode methodsFor: 'testing' stamp: 'ThierryGoubier 7/31/2012 22:46'!
isStyled
	^ true! !

!ABMethodCategoryNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/31/2012 22:00'!
methodCategory
	^ item! !

!ABMethodCategoryNode methodsFor: 'private' stamp: 'ThierryGoubier 7/17/2012 13:54'!
privateClass
	^ self parentNode privateClass! !

!ABMethodCategoryNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/17/2012 13:53'!
sourceClass
	^ self parentNode item! !

!ABMethodCategoryNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/31/2012 22:09'!
sourceCode
	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!ABMethodCategoryNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 14:41'!
treeAreaCommands
	<treeAreaCommand>
	^ {AltAddProtocolCommand. AltRemoveProtocolCommand }! !

ABAbstractNode subclass: #ABMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABMethodNode commentStamp: '<historical>' prior: 0!
Represent a method. Should be used to get the method source, selector and whatever.!

!ABMethodNode methodsFor: 'actions' stamp: 'ThierryGoubier 9/22/2012 10:06'!
accept: aText notifying: aController
	"Compile the method. All accept: methods should return the relevant object created or modified, for tracking by the GUI."

	"There is something about notifying here."

	| aSelector |
	aSelector := self sourceClass compile: aText classified: self parentNode methodCategory notifying: aController.
	self parentNode rebuildContents.
	^ self parentNode contents detect: [ :each | each item == aSelector ]! !

!ABMethodNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/22/2012 09:32'!
compiledMethod
	^ self parentNode privateClass compiledMethodAt: self item! !

!ABMethodNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/7/2012 14:16'!
findMethod: anItem in: aClass
	^ (item == anItem and: [ self sourceClass == aClass ])
		ifTrue: [ self ]
		ifFalse: [ nil ]! !

!ABMethodNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/10/2012 19:29'!
formatCommand
	<textAreaCommand>
	^ {AltRBFormatCommand}! !

!ABMethodNode methodsFor: 'testing' stamp: 'ThierryGoubier 7/19/2012 23:22'!
isStyled
	^ true! !

!ABMethodNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 14:39'!
navigationCommands
	<treeAreaCommand>
	^ {AltGoToSuperMethodCommand.
	AltImplementorsCommand.
	AltSendersCommand.
	AltBrowseVersionsCommand}! !

!ABMethodNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 14:45'!
removeCommand
	<treeAreaCommand>
	^ {AltRemoveMethodCommand}! !

!ABMethodNode methodsFor: 'commands' stamp: 'ThierryGoubier 11/21/2012 10:04'!
runTestCommand
	<treeAreaCommand>
	^ {AltDebugTestCommand}! !

!ABMethodNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 14:38'!
searchTextCommands
	<textAreaCommand>
	^ {AltImplementorsTextCommand}! !

!ABMethodNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/17/2012 13:55'!
sourceClass
	"Get the class through the parent."

	^ (self parentNode privateClass compiledMethodAt: self item) methodClass! !

!ABMethodNode methodsFor: 'querying' stamp: 'ThierryGoubier 7/17/2012 13:55'!
sourceCode
	"Get the source code through the parent."

	^ (self parentNode privateClass compiledMethodAt: self item) sourceCode! !

!ABMethodNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/21/2012 16:13'!
title
	^ self sourceClass name, '>>', item! !

ABAbstractNode subclass: #ABPackageCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABPackageCategoryNode commentStamp: '<historical>' prior: 0!
An ABPackageCategoryNode represent a category of packages.

item contains an association "package category name" -> "list of packages.".

!

!ABPackageCategoryNode methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 09:44'!
addChild: anItem
	"Add a child, but do it according to it's position."

	| d |
	item value add: anItem.
	d := self childrenItems indexOf: anItem.
	contents isNil ifTrue: [^nil] ifFalse: [
	^ contents add: (self childNodeFromItem: anItem) beforeIndex: d]! !

!ABPackageCategoryNode methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 10:21'!
addChildItem: anItem
	"Add a child, but do it according to it's position."

	| d |
	self contents.	"Force contents creation."
	item value add: anItem item.
	anItem parentNode: self.
	^ contents add: anItem! !

!ABPackageCategoryNode methodsFor: 'accessing' stamp: 'ThierryGoubier 8/30/2012 06:59'!
addChildItem: anItem beforeIndex: anIndex
	"Add a child, but do it according to it's position."

	| d |
	self contents.	"Force contents creation."
	item value add: anItem item beforeIndex: anIndex.
	anItem parentNode: self.
	^ contents add: anItem beforeIndex: anIndex! !

!ABPackageCategoryNode methodsFor: 'printing' stamp: 'ThierryGoubier 7/14/2012 23:17'!
asString
	^ item key! !

!ABPackageCategoryNode methodsFor: 'private' stamp: 'ThierryGoubier 9/19/2012 22:23'!
childNodeClassFromItem: anItem
	(anItem isKindOf: Association )
		ifTrue: [ ^ self class ].
	^ ABPackageSetNode! !

!ABPackageCategoryNode methodsFor: 'private' stamp: 'ThierryGoubier 7/14/2012 23:18'!
childrenItems
	^ item value! !

!ABPackageCategoryNode methodsFor: 'drag and drop' stamp: 'ThierryGoubier 10/17/2012 15:58'!
dropItem: anItem
	"Ok. If we receive a category or a package we either add it to its
	children (if it has no children ?) or add it just before this item?"

	((anItem isKindOf: ABPackageCategoryNode) or: [ anItem isKindOf: ABPackageNode ])
		ifFalse: [ ^ nil ].
	anItem parentNode isNil
		ifTrue: [ AltBrowser rootItems remove: anItem ]
		ifFalse: [ anItem parentNode removeChildItem: anItem ].
	AltBrowser announcer announce: (AltNodeRemoved node: anItem).
	self childrenItems isEmpty
		ifTrue: [ self addChildItem: anItem ]
		ifFalse: [ 
			self parentNode isNil
				ifTrue: [ 
					AltBrowser rootItems add: anItem before: self.
					anItem parentNode: nil ]
				ifFalse: [ self parentNode addChildItem: anItem beforeIndex: (self parentNode contents indexOf: self) ] ].
	AltBrowser announcer announce: (AltNodeAdded node: anItem).
	^ anItem! !

!ABPackageCategoryNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 16:21'!
findMethod: aSelector in: aClass
	"Return the node if the item matches. By default, search among the kids."

	"Not  lazy : force contents generation."

	| res |
	self contents
		do: [ :each | 
			(res := each findMethod: aSelector in: aClass) notNil
				ifTrue: [ ^ res ] ].
	^ nil! !

!ABPackageCategoryNode methodsFor: 'commands' stamp: 'ThierryGoubier 10/15/2012 14:45'!
rcTreeCommands
	<treeAreaCommand>
	^ {AltRemovePackageCategoryCommand.
	AltCreatePackageCategoryCommand}! !

!ABPackageCategoryNode methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 21:24'!
removeChildItem: anItem
	"Remove a child."

	| d |
	item value remove: anItem item.
	contents isNil
		ifTrue: [ ^ nil ]
		ifFalse: [ ^ contents remove: anItem ]! !

!ABPackageCategoryNode methodsFor: 'querying' stamp: 'ThierryGoubier 8/30/2012 22:16'!
sourceCode
	"A description of the group."
	
	^ 'Package group : ', item key, '
	All packages classified under the term ', item key! !

!ABPackageCategoryNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/21/2012 16:19'!
title
	^ item key! !

ABAbstractNode subclass: #ABPackageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABPackageNode commentStamp: '<historical>' prior: 0!
An ABPackageNode represent a package and all classes matching it (categories).
!

ABPackageNode subclass: #ABPackageExtensionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABPackageExtensionNode commentStamp: '<historical>' prior: 0!
An ABPackageExtensionNode is for the extensions part of a package.!

!ABPackageExtensionNode methodsFor: 'printing' stamp: 'ThierryGoubier 7/17/2012 13:31'!
asString
	^ '*extensions*'! !

!ABPackageExtensionNode methodsFor: 'private' stamp: 'ThierryGoubier 7/17/2012 13:38'!
childNodeClassFromItem: anItem
	^ ABClassExtensionNode! !

!ABPackageExtensionNode methodsFor: 'private' stamp: 'ThierryGoubier 8/27/2012 00:19'!
childrenItems
	^ self item extendedClasses! !

!ABPackageExtensionNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/20/2012 22:02'!
findAllMethodParents: aSelector forClass: aClass
	"Returns an OrderedCollection for self"

	^ (self item includesExtensionSelector: aSelector ofClass: aClass)
		ifTrue: [ OrderedCollection with: self ]
		ifFalse: [ nil ]! !

!ABPackageNode methodsFor: 'actions' stamp: 'ThierryGoubier 10/17/2012 15:58'!
accept: aText notifying: aController
	| res |
	res := [ 
	UndefinedObject evaluatorClass new
		evaluate: (ReadStream on: aText)
		in: nil
		to: nil
		notifying: aController
		ifFail: [ ^ nil ]
		logged: true ]
		on: OutOfScopeNotification
		do: [ :ex | ex resume: true ].
	res notNil
		ifTrue: [ 
			| r |
			AltBrowser rootItems detect: [ :aRoot | (r := aRoot findClass: res) notNil ].
			^ r ].
	^ nil! !

!ABPackageNode methodsFor: 'printing' stamp: 'ThierryGoubier 7/15/2012 07:49'!
asString
	^ self item packageName! !

!ABPackageNode methodsFor: 'private' stamp: 'ThierryGoubier 8/31/2012 07:59'!
childNodeClassFromItem: anItem
	((anItem isKindOf: Class) or: [ (anItem isKindOf: Metaclass) or: [ anItem isTrait ] ])
		ifTrue: [ ^ ABClassNode ].
	(anItem isKindOf: RPackage)
		ifTrue: [ ^ ABPackageExtensionNode ].
	^ ABClassCategoryNode! !

!ABPackageNode methodsFor: 'private' stamp: 'ThierryGoubier 9/22/2012 09:09'!
childrenItems
	"Extract from the organisation the various classes. Use the same implementation as the Class Category, if only one category."
	
	"For the time being, do not track tags in RPackages."

	| o |
	o := OrderedCollection new.
	o add: self item.
	o addAll: (ABClassCategoryNode orderClasses: self item definedClasses asOrderedCollection).
	^ o! !

!ABPackageNode methodsFor: 'drag and drop' stamp: 'ThierryGoubier 10/17/2012 15:58'!
dropItem: anItem
	"Ok. If we receive a category, then we add the category at the end of the parent node. It amounts to removing a node from the root items and adding it here."

	((anItem isKindOf: ABPackageCategoryNode) or: [ anItem isKindOf: ABPackageNode ])
		ifFalse: [ ^ self ].
	anItem parentNode isNil
		ifTrue: [ AltBrowser rootItems remove: anItem ]
		ifFalse: [ anItem parentNode removeChildItem: anItem ].
	AltBrowser announcer announce: (AltNodeRemoved node: anItem).
	self parentNode addChildItem: anItem beforeIndex: (parentNode contents indexOf: self).
	AltBrowser announcer announce: (AltNodeAdded node: anItem)! !

!ABPackageNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 17:15'!
findClass: aClass
	"Filter out: force contents building if the class belongs to this package."
	
	| res |
	(self item includesClass: aClass)
		ifTrue: [ self contents do: [ :each | 
							(res := each findClass: aClass) notNil
								ifTrue: [ ^ res ]] ].
	^ nil! !

!ABPackageNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 16:18'!
findMethod: aSelector in: aClass
	"Filter out: force contents building if the class belongs to this package."
	
	| res |
	(self item includesClass: aClass)
		ifTrue: [ self contents do: [ :each | 
							(res := each findMethod: aSelector in: aClass) notNil
								ifTrue: [ ^ res ]] ].
	^ nil! !

!ABPackageNode methodsFor: 'querying' stamp: 'ThierryGoubier 8/31/2012 07:48'!
findPackage: aRPackage
	"As a package extension node inherit and is set below, then it is never reached."

	^ item == aRPackage
		ifTrue: [ self ]
		ifFalse: [ nil ]! !

!ABPackageNode methodsFor: 'testing' stamp: 'ThierryGoubier 9/23/2012 22:16'!
isStyled
	^ true! !

!ABPackageNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 22:16'!
sourceCode
	"The default class scheme for a package."

	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self item packageName, ''''! !

!ABPackageNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/21/2012 16:21'!
title
	^ item packageName! !

ABAbstractNode subclass: #ABPackageSetNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABPackageSetNode commentStamp: '<historical>' prior: 0!
This class instances represent PackageSets or MCWorkingCopy of a package.!

!ABPackageSetNode methodsFor: 'actions' stamp: 'ThierryGoubier 10/17/2012 15:58'!
accept: aText notifying: aController
	| res |
	res := [ 
	UndefinedObject evaluatorClass new
		evaluate: (ReadStream on: aText)
		in: nil
		to: nil
		notifying: aController
		ifFail: [ ^ nil ]
		logged: true ]
		on: OutOfScopeNotification
		do: [ :ex | ex resume: true ].
	res notNil
		ifTrue: [ 
			| r |
			AltBrowser rootItems detect: [ :aRoot | (r := aRoot findClass: res) notNil ].
			^ r ].
	^ nil! !

!ABPackageSetNode methodsFor: 'printing' stamp: 'ThierryGoubier 9/21/2012 14:58'!
asString
	(item isKindOf: MCWorkingCopy)
		ifTrue: [^ self item packageNameWithStar ].
	^ item printString! !

!ABPackageSetNode methodsFor: 'private' stamp: 'ThierryGoubier 9/19/2012 22:04'!
childNodeClassFromItem: anItem
	((anItem isKindOf: RPackage) and: [ self item packageSet packages size = 1 ])
		ifTrue: [ ^ ABPackageExtensionNode ].
	(anItem isKindOf: RPackage)
		ifTrue: [ ^ ABPackageNode ].
	^ ABClassNode! !

!ABPackageSetNode methodsFor: 'private' stamp: 'ThierryGoubier 9/19/2012 22:19'!
childrenItems
	| o |
	o := OrderedCollection new.
	self item packageSet packages size = 1
		ifTrue: [ 
			| package |
			package := self item packageSet packages first.
			o add: package.
			o addAll: (ABClassCategoryNode orderClasses: package definedClasses asOrderedCollection) ]
		ifFalse: [ o addAll: self item packageSet packages ].
	^ o! !

!ABPackageSetNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 16:20'!
findMethod: aSelector in: aClass
	"Return the node if the item matches. By default, search among the kids."

	"Not lazy : trigger contents generation."

	| res |
	self contents
		do: [ :each | 
			(res := each findMethod: aSelector in: aClass) notNil
				ifTrue: [ ^ res ] ].
	^ nil! !

!ABPackageSetNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/23/2012 22:59'!
findPackage: aRPackage
	"If a package set has a single package, then the package set takes the package place in the tree and reacts as such."

	| pkSet pks |
	pkSet := item packageSet.
	pks := pkSet packages.
	(pks size = 1 and: [ pks first == aRPackage ])
		ifTrue: [ ^ self ]
		ifFalse: [ ^ super findPackage: aRPackage ]! !

!ABPackageSetNode methodsFor: 'querying' stamp: 'ThierryGoubier 9/21/2012 10:25'!
findPackageSet: aPackageSetOrMCWorkingCopy
	^ (item = aPackageSetOrMCWorkingCopy or: [ item packageSet = aPackageSetOrMCWorkingCopy or: [item package = aPackageSetOrMCWorkingCopy]])
		ifTrue: [ self ]
		ifFalse: [ nil ]! !

!ABPackageSetNode methodsFor: 'testing' stamp: 'ThierryGoubier 9/23/2012 22:25'!
isStyled
	^ true! !

!ABPackageSetNode methodsFor: 'private' stamp: 'ThierryGoubier 9/23/2012 22:26'!
sourceCode
	"The default class scheme for a package."

	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self item packageName, ''''! !

!ABPackageSetNode methodsFor: 'accessing' stamp: 'ThierryGoubier 9/21/2012 16:20'!
title
	^ item packageNameWithStar! !

Object subclass: #AltCommand
	instanceVariableNames: 'target requestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltCommand commentStamp: '<historical>' prior: 0!
An ABCommand is in charge of preparing and executing commands on the Alt Browser.

Instance Variables
	requestor:	<Object>	The object sending the command. In my case, the AltBrowser instance.
	target:		<Object>	The target (where the command is applied): the textModel usually (or the treeModel for tree related commands ?)!

AltCommand subclass: #AltAcceptTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltAcceptTextCommand commentStamp: '<historical>' prior: 0!
An ABAcceptTextCommand is about accepting the text.
!

!AltAcceptTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!AltAcceptTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!AltAcceptTextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/1/2012 21:53'!
execute
	"The execute may create an object or return us one."

	| result selection |
	target accept.
	selection := requestor selectedNode item.
	result := selection accept: target text notifying: target.
	(result isNil or: [ result == selection ])
		ifTrue: [ ^ self ].
	requestor selectPathForAbstractItem: result! !

!AltAcceptTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 10:39'!
group
	^ #zip! !

!AltAcceptTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/17/2012 23:17'!
icon
	^ #smallOkIcon! !

!AltAcceptTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:21'!
isActive
	^ true! !

!AltAcceptTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:50'!
keystroke
	^ $s ctrl ! !

!AltAcceptTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:09'!
label
	^ 'Accept'! !

AltCommand subclass: #AltAddProtocolCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltAddProtocolCommand methodsFor: 'execution' stamp: 'ThierryGoubier 9/30/2012 13:36'!
execute
	"Reuse code from Browser>>addCategory"

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"

	"Usability comment : far too many choices in most cases to be user-friendly."

	| labels reject lines oldIndex newName tClass sItem |
	requestor okToChange
		ifFalse: [ ^ self ].
	labels := OrderedCollection new.
	sItem := requestor selectedNode.
	tClass := sItem sourceClass.
	reject := Set new.
	reject
		addAll: tClass organization categories;
		add: ClassOrganizer nullCategory;
		add: ClassOrganizer default.
	lines := OrderedCollection new.
	tClass allSuperclasses
		do: [ :cls | 
			| cats |
			cls = Object
				ifFalse: [ 
					cats := cls organization categories reject: [ :cat | reject includes: cat ].
					(cats isEmpty or: [ reject size > 10 ])
						ifFalse: [ 
							lines add: labels size.
							labels addAll: cats asSortedCollection.
							reject addAll: cats ] ] ].
	newName := UIManager default chooseOrRequestFrom: labels lines: lines title: 'Add Category'.
	newName ifNil: [ ^ self ].
	newName := newName asSymbol.
	tClass
		addCategory: newName
		before:
			((sItem item isKindOf: ABMethodCategoryNode)
				ifTrue: [ sItem item item ]
				ifFalse: [ nil ]).
	requestor selectPathForAbstractItem: (sItem parentNode findItem: (sItem parentNode item findMethodCategory: newName in: tClass)) item! !

!AltAddProtocolCommand methodsFor: 'testing' stamp: 'ThierryGoubier 8/29/2012 10:39'!
isActive
	^ true! !

!AltAddProtocolCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/29/2012 10:39'!
label
	^ 'Add protocol'! !

AltCommand subclass: #AltBrowseVersionsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltBrowseVersionsCommand commentStamp: '<historical>' prior: 0!
This command opens a version browser on a method.!

!AltBrowseVersionsCommand methodsFor: 'execution' stamp: 'ThierryGoubier 9/30/2012 13:37'!
execute
	| class selector |
	class := requestor selectedNode sourceClass.
	selector := requestor selectedNode item item.
	Smalltalk tools versionBrowser
		browseVersionsOf: (class compiledMethodAt: selector)
		class: class theNonMetaClass
		meta: class isMeta
		category: requestor selectedNode item parentNode methodCategory
		selector: selector! !

!AltBrowseVersionsCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/19/2012 10:24'!
icon
	^ #smallSystemBrowserIcon! !

!AltBrowseVersionsCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/19/2012 10:34'!
isActive
	^ true! !

!AltBrowseVersionsCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/19/2012 10:33'!
isEnabled
	^ true! !

!AltBrowseVersionsCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/19/2012 10:24'!
keystroke
	^ $v command! !

!AltBrowseVersionsCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/19/2012 10:24'!
label
	^ 'Versions'! !

AltCommand subclass: #AltCancelTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltCancelTextCommand commentStamp: '<historical>' prior: 0!
An ABCancelTextCommand is about cancelling the last action.!

!AltCancelTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!AltCancelTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!AltCancelTextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/1/2012 21:53'!
execute
	target cancel! !

!AltCancelTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 10:39'!
group
	^ #zip! !

!AltCancelTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/17/2012 23:17'!
icon
	^ #smallCancelIcon! !

!AltCancelTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:22'!
isActive
	^ true! !

!AltCancelTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:51'!
keystroke
	^ $l ctrl! !

!AltCancelTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:11'!
label
	^ 'Cancel'! !

AltCommand subclass: #AltClassRefsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltClassRefsCommand methodsFor: 'execution' stamp: 'ThierryGoubier 9/30/2012 13:37'!
execute
	"Strange, but convenient, to see that systemNavigation is defined for every object."

	| class |
	class := requestor selectedNode item item theNonMetaClass ifNil: [ ^ self ].
	class isTrait
		ifTrue: [ self systemNavigation browseAllUsersOfTrait: class ]
		ifFalse: [ self systemNavigation browseAllCallsOnClass: class ]! !

!AltClassRefsCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/10/2012 16:09'!
icon
	^ #smallFindIcon! !

!AltClassRefsCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/10/2012 16:26'!
isActive
	^ true! !

!AltClassRefsCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/10/2012 16:15'!
isEnabled
	^ true! !

!AltClassRefsCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/10/2012 16:02'!
label
	^ 'Class refs'! !

!AltClassRefsCommand methodsFor: 'user interface' stamp: 'ThierryGoubier 9/10/2012 16:50'!
neo! !

!AltCommand class methodsFor: 'instance creation' stamp: 'cwp 10/14/2006 23:29'!
on: target for: requestor
	^ self new setTarget: target requestor: requestor! !

!AltCommand methodsFor: 'user interface' stamp: 'ThierryGoubier 9/11/2012 13:10'!
addItemToMenu: aMenu
	(self isActive and: [ self wantsMenu ])
		ifTrue: [ 
			(aMenu add: self label target: self selector: #execute)
				enablementSelector: #isEnabled;
				icon:
						(self icon notNil
								ifTrue: [ UITheme current perform: self icon ]
								ifFalse: [ nil ]);
				keyText: self keyString ]! !

!AltCommand methodsFor: 'user interface' stamp: 'ThierryGoubier 9/12/2012 16:25'!
buildShortcut: aKMDispatcher
	"Add a shortcut to the keymap. Conditions : must have a keystroke, must wantsKeyboard and must be active."

	(self keystroke isNil or: [ self wantsKeyboard not or: [ self isActive not ] ])
		ifTrue: [ ^ self ].
	aKMDispatcher
		on: self keystroke asShortcut
		do: [ self execute ]! !

!AltCommand methodsFor: 'execution' stamp: 'cwp 10/15/2006 14:12'!
execute
	! !

!AltCommand methodsFor: 'accessing' stamp: 'cwp 10/6/2006 18:45'!
icon
	^ nil! !

!AltCommand methodsFor: 'testing' stamp: 'cwp 10/15/2006 22:05'!
isActive
	^ false! !

!AltCommand methodsFor: 'testing' stamp: 'cwp 10/15/2006 19:31'!
isEnabled
	^ true! !

!AltCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/7/2012 22:49'!
keyString
	| c |
	^ (c := self keystroke) isNil
		ifFalse: [ c asString copyWithout: Character space ]
		ifTrue: [ nil ]! !

!AltCommand methodsFor: 'accessing' stamp: 'cwp 9/27/2006 22:53'!
keystroke
	^ nil
! !

!AltCommand methodsFor: 'accessing' stamp: 'cwp 9/27/2006 22:53'!
label
	self subclassResponsibility
! !

!AltCommand methodsFor: 'accessing' stamp: 'cwp 10/14/2006 23:39'!
on: anObject for: aRequestor
	^ self class on: anObject for: aRequestor! !

!AltCommand methodsFor: 'user interface' stamp: 'cwp 10/15/2006 12:37'!
perform: aSelector orSendTo: anObject
	self perform: aSelector! !

!AltCommand methodsFor: 'user interface' stamp: 'lr 11/25/2010 23:45'!
select: aNode with: anAnnouncer
	aNode announceSelectionWith: anAnnouncer! !

!AltCommand methodsFor: 'initialize-release' stamp: 'lr 7/3/2009 22:27'!
setTarget: anObject requestor: aRequestor 
	target := anObject.
	requestor := aRequestor! !

!AltCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/11/2012 13:11'!
wantsButton
	"Select for button use. Reserved for future use (a menu bar ?)."

	^ false
! !

!AltCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/11/2012 13:11'!
wantsKeyboard
	"Select for keyboard use."

	^ true
! !

!AltCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/11/2012 13:07'!
wantsMenu
	"true if the command wants to be in Menus."

	^ true
! !

AltCommand subclass: #AltCopyTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltCopyTextCommand commentStamp: '<historical>' prior: 0!
This class does a copy on the text area.!

!AltCopyTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!AltCopyTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!AltCopyTextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/1/2012 21:53'!
execute
	target copySelection! !

!AltCopyTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/17/2012 23:17'!
icon
	^ #smallCopyIcon! !

!AltCopyTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:22'!
isActive
	^ true! !

!AltCopyTextCommand methodsFor: 'testing' stamp: 'ThierryGoubier 10/1/2012 21:53'!
isEnabled
	^ target trueSelection isEmpty not! !

!AltCopyTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:51'!
keystroke
	^ $c ctrl! !

!AltCopyTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:11'!
label
	^ 'Copy'! !

!AltCopyTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:29'!
order
	^ '2'! !

AltCommand subclass: #AltCreatePackageCategoryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltCreatePackageCategoryCommand commentStamp: '<historical>' prior: 0!
This class prompts for a name and creates a category at top level.
!

!AltCreatePackageCategoryCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/17/2012 15:58'!
execute
	"Ask for a category name and create it."

	| name |
	name := UIManager default request: 'New Category name?'.
	name notNil
		ifTrue: [ 
			| item |
			item := ABPackageCategoryNode with: name -> OrderedCollection new.
			requestor selectedNode notNil
				ifTrue: [ AltBrowser rootItems add: item afterIndex: (AltBrowser rootItems indexOf: requestor selectedNode item) ]
				ifFalse: [ AltBrowser rootItems add: item ].
			AltBrowser announcer announce: (AltNodeAdded node: item) ]! !

!AltCreatePackageCategoryCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/31/2012 15:52'!
icon
	^ nil! !

!AltCreatePackageCategoryCommand methodsFor: 'testing' stamp: 'ThierryGoubier 7/31/2012 15:54'!
isActive
	^ true! !

!AltCreatePackageCategoryCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/30/2012 14:32'!
isEnabled
	^ requestor selectedNode isNil or: [ requestor selectedNode item isKindOf: ABPackageCategoryNode ]! !

!AltCreatePackageCategoryCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/31/2012 15:58'!
label
	^'Create '! !

AltCommand subclass: #AltCutCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltCutCommand commentStamp: '<historical>' prior: 0!
This command starts a move, different from a delete. It's focusing on giving the same behavior as the cut / paste of file browsers.!

!AltCutCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/17/2012 15:58'!
execute
	"Use the AltBrowserModel temporary to store the item."

	AltBrowser temporary: requestor selectedNode item! !

!AltCutCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/9/2012 22:10'!
icon
	^ #smallCutIcon! !

!AltCutCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/9/2012 22:13'!
isActive
	^ true! !

!AltCutCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/9/2012 22:12'!
isEnabled
	^ true! !

!AltCutCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/9/2012 22:14'!
keystroke
	^ $x ctrl! !

!AltCutCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/9/2012 22:09'!
label
	^ 'Cut'
	! !

AltCommand subclass: #AltCutTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltCutTextCommand commentStamp: '<historical>' prior: 0!
This class does a cut in the text area.
!

!AltCutTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!AltCutTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!AltCutTextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/1/2012 21:54'!
execute
	target cut! !

!AltCutTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/17/2012 23:17'!
icon
	^ #smallCutIcon! !

!AltCutTextCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/19/2012 10:43'!
isActive
	^ true! !

!AltCutTextCommand methodsFor: 'testing' stamp: 'ThierryGoubier 11/18/2012 01:26'!
isEnabled
	^ target trueSelection isEmpty not! !

!AltCutTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/21/2012 09:58'!
keystroke
	^ $x ctrl! !

!AltCutTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:12'!
label
	^ 'Cut'! !

!AltCutTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:29'!
order
	^ '1'! !

AltCommand subclass: #AltDebugTestCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltDebugTestCommand commentStamp: '<historical>' prior: 0!
This command run the related test, if the selected method is apparently a test.

Is active if the selected item class inherits from TestCase. Is enabled if the method start by 'test'.

Does not run the test, but debug it. Is a more convenient way of running the test by hand, and avoid, as it is the case in Nautilus and OmniBrowser, to have two tests runs if it fails (and, in some cases, twice the effect of running the test).!

!AltDebugTestCommand methodsFor: 'execution' stamp: 'ThierryGoubier 11/20/2012 20:27'!
execute
	"Run the test and notify?"

	requestor selectedNode sourceClass run: requestor selectedNode item item! !

!AltDebugTestCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 11/21/2012 10:50'!
icon
	^ #smallDoItIcon! !

!AltDebugTestCommand methodsFor: 'testing' stamp: 'ThierryGoubier 11/21/2012 07:11'!
isActive
	^ requestor selectedNode sourceClass inheritsFrom: TestCase! !

!AltDebugTestCommand methodsFor: 'testing' stamp: 'ThierryGoubier 11/20/2012 20:22'!
isEnabled
	^ (requestor selectedNode sourceClass inheritsFrom: TestCase) and: [ requestor selectedNode item item beginsWith: 'test' ]! !

!AltDebugTestCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 11/20/2012 20:23'!
label
	^ 'Run test'! !

AltCommand subclass: #AltDoItTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltDoItTextCommand commentStamp: '<historical>' prior: 0!
ABDoItTextCommand : execute the code selected
!

AltDoItTextCommand subclass: #AltDebugItTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltDebugItTextCommand commentStamp: '<historical>' prior: 0!
This class does a debugIt on the selection in the text area.
!

!AltDebugItTextCommand class methodsFor: 'testing' stamp: 'lr 8/27/2011 10:02'!
takesNodes
	^ false! !

!AltDebugItTextCommand class methodsFor: 'testing' stamp: 'lr 8/27/2011 10:02'!
takesText
	^ true! !

!AltDebugItTextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/1/2012 21:54'!
execute
	target debugIt! !

!AltDebugItTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/17/2012 23:17'!
icon
	^ #smallDebugIcon! !

!AltDebugItTextCommand methodsFor: 'testing' stamp: 'lr 8/27/2011 09:58'!
isActive
	^ true! !

!AltDebugItTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/10/2012 22:12'!
keystroke
	^ $d command shift! !

!AltDebugItTextCommand methodsFor: 'accessing' stamp: 'lr 8/27/2011 09:58'!
label
	^ 'Debug it'! !

!AltDebugItTextCommand methodsFor: 'accessing' stamp: 'lr 8/27/2011 10:00'!
order
	^ '5'! !

!AltDoItTextCommand class methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
takesNodes
	^ false! !

!AltDoItTextCommand class methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
takesText
	^ true! !

!AltDoItTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/17/2012 11:29'!
doItContext

	^ nil! !

!AltDoItTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/30/2012 14:32'!
doItReceiver

	^ requestor selectedNode sourceClass
		ifNil: [ nil ]
		ifNotNil: [:class | class theNonMetaClass ]! !

!AltDoItTextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/3/2012 17:06'!
execute
	"Treat the current selection as an expression; evaluate it."

	| result rcvr ctxt |
	rcvr := self doItReceiver.
	ctxt := self doItContext.
	result := [ 
	rcvr class evaluatorClass new
		evaluate: (ReadStream on: target trueSelection)
		in: ctxt
		to: rcvr
		notifying: target
		ifFail: [ 
			target flash.
			^ nil ]
		logged: true	"don't set it to self.. The receiver can be destroyed as a result of evaluateSelection" ]
		on: OutOfScopeNotification
		do: [ :ex | ex resume: true ].
	^ result! !

!AltDoItTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/17/2012 23:18'!
icon
	^ #smallDoItIcon! !

!AltDoItTextCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/25/2012 23:29'!
isActive
	^ target readSelection notNil! !

!AltDoItTextCommand methodsFor: 'testing' stamp: 'ThierryGoubier 10/1/2012 21:54'!
isEnabled
	^ target trueSelection notEmpty! !

!AltDoItTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:51'!
keystroke
	^ $d command! !

!AltDoItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:55'!
label
	^ 'Do it'! !

AltDoItTextCommand subclass: #AltExploreItTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltExploreItTextCommand commentStamp: '<historical>' prior: 0!
This class does an exploreIt (evaluate and explore) on the contents selected in the text area.
!

!AltExploreItTextCommand class methodsFor: 'testing' stamp: 'lr 3/6/2011 15:08'!
takesNodes
	^ false! !

!AltExploreItTextCommand class methodsFor: 'testing' stamp: 'lr 3/6/2011 15:08'!
takesText
	^ true! !

!AltExploreItTextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 7/26/2012 13:47'!
execute
	super execute explore! !

!AltExploreItTextCommand methodsFor: 'testing' stamp: 'lr 3/6/2011 15:05'!
isActive
	^ true! !

!AltExploreItTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:52'!
keystroke
	^ $I command! !

!AltExploreItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 15:05'!
label
	^ 'Explore it'! !

!AltExploreItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 15:05'!
order
	^ '4'! !

AltDoItTextCommand subclass: #AltInspectItTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltInspectItTextCommand commentStamp: '<historical>' prior: 0!
This class does an inspectIt (evaluate and inspect the result) on the selection in the text area.
!

!AltInspectItTextCommand class methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
takesNodes
	^ false! !

!AltInspectItTextCommand class methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
takesText
	^ true! !

!AltInspectItTextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 7/26/2012 13:48'!
execute
	super execute inspect! !

!AltInspectItTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/17/2012 23:18'!
icon
	^ #smallInspectItIcon! !

!AltInspectItTextCommand methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
isActive
	^ true! !

!AltInspectItTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:52'!
keystroke
	^ $i command! !

!AltInspectItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:56'!
label
	^ 'Inspect it'! !

!AltInspectItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:56'!
order
	^ '3'! !

AltDoItTextCommand subclass: #AltPrintItTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltPrintItTextCommand commentStamp: '<historical>' prior: 0!
This command does a printIt (evaluate and print the result) on the selection in the text area.!

!AltPrintItTextCommand class methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
takesNodes
	^ false! !

!AltPrintItTextCommand class methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
takesText
	^ true! !

!AltPrintItTextCommand methodsFor: 'execution' stamp: 'lr 3/6/2011 15:13'!
execute
	target printIt! !

!AltPrintItTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/17/2012 23:18'!
icon
	^ #smallPrintIcon! !

!AltPrintItTextCommand methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
isActive
	^ true! !

!AltPrintItTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:53'!
keystroke
	^ $p command! !

!AltPrintItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:56'!
label
	^ 'Print it'! !

!AltPrintItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:56'!
order
	^ '2'! !

AltCommand subclass: #AltExploreItemCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltExploreItemCommand commentStamp: '<historical>' prior: 0!
An ABExploreItemCommand does an explore of the selected item in the tree pane.
!

!AltExploreItemCommand methodsFor: 'execution' stamp: 'ThierryGoubier 9/30/2012 14:32'!
execute
	requestor selectedNode item explore! !

!AltExploreItemCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/30/2012 16:51'!
icon
	^ #smallInspectItIcon! !

!AltExploreItemCommand methodsFor: 'testing' stamp: 'ThierryGoubier 10/17/2012 15:58'!
isActive
	^ AltBrowser debug! !

!AltExploreItemCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/30/2012 14:32'!
isEnabled
	^ requestor selectedNode notNil! !

!AltExploreItemCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 22:07'!
keystroke
	^ $l command! !

!AltExploreItemCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/30/2012 16:49'!
label
	^ 'ExploreIt'! !

AltCommand subclass: #AltFindClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltFindClassCommand commentStamp: '<historical>' prior: 0!
This command does a find class. Use an openPath approach.!

!AltFindClassCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/17/2012 15:58'!
execute
	"Find a class, then determine the path to reach it, and open this path. Select only one node, and if there is more than one match, use the last match (multiple matches means in current RPackage an additional, incorrect, overall package which is usually before the real, most specific package)."

	"In fact, this is costly (scan of the complete tree) even if it is fast enough, since sometimes the over package is before (Alt), sometimes it is after (Rpackage). It may be irrelevant with evolutions in RPackage."

	| aClass found aNode nPath tmPath |
	aClass := SearchFacade classSearch chooseFromOwner: target owner.
	aClass isNil
		ifTrue: [ ^ self ].
	AltBrowser rootItems
		do: [ :each | 
			| res |
			(res := each findClass: aClass) notNil
				ifTrue: [ found := res ] ].
	found isNil
		ifTrue: [ ^ aClass explore ].
	requestor selectPathForAbstractItem: found! !

!AltFindClassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/7/2012 22:51'!
icon
	^ nil! !

!AltFindClassCommand methodsFor: 'testing' stamp: 'ThierryGoubier 8/7/2012 22:50'!
isActive
	^ true! !

!AltFindClassCommand methodsFor: 'testing' stamp: 'ThierryGoubier 8/7/2012 22:50'!
isEnabled
	^ true! !

!AltFindClassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/15/2012 10:27'!
keystroke
	^ $f command, $c asShortcut! !

!AltFindClassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/7/2012 22:50'!
label
	^ 'Find Class'! !

AltCommand subclass: #AltGoToSubclassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltGoToSubclassCommand commentStamp: '<historical>' prior: 0!
This command brings you to the first subclass of a class
!

!AltGoToSubclassCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/17/2012 15:58'!
execute
	"To be done."
	
	| found aClass |
	aClass := requestor selectedNode item item subclasses first.
	AltBrowser rootItems
		do: [ :each | 
			| res |
			(res := each findClass: aClass) notNil
				ifTrue: [ found := res ] ].
	requestor selectPathForAbstractItem: found! !

!AltGoToSubclassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/5/2012 14:49'!
icon
	^ nil! !

!AltGoToSubclassCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/5/2012 16:45'!
isActive
	^ true! !

!AltGoToSubclassCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/30/2012 14:33'!
isEnabled
	^ requestor selectedNode item item subclasses notEmpty! !

!AltGoToSubclassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/15/2012 11:57'!
keystroke
	^ $n command, $u! !

!AltGoToSubclassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/5/2012 14:50'!
label
	^ 'Subclass'! !

AltCommand subclass: #AltGoToSuperMethodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltGoToSuperMethodCommand commentStamp: '<historical>' prior: 0!
This class does a navigation move to a superclass method of the same name (overridden then by the current one)!

!AltGoToSuperMethodCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/17/2012 15:58'!
execute
	"Move to that place. Can only be called if enabled."

	| tClass tClassNode tMethodNode |
	tClass := self findTargetClass.
	self assert: tClass notNil.
	AltBrowser rootItems detect: [ :each | (tClassNode := each findClass: tClass) notNil ].
	tMethodNode := tClassNode findMethod: requestor selectedNode item item in: tClass.
	requestor selectPathForAbstractItem: tMethodNode! !

!AltGoToSuperMethodCommand methodsFor: 'execution' stamp: 'ThierryGoubier 9/30/2012 14:34'!
findTargetClass
	"Move to that place. We will check if this works for selection first."
	
	requestor selectedNode sourceClass
		allSuperclassesDo: [ :each | 
			(each includesSelector: requestor selectedNode item item)
				ifTrue: [ ^ each ] ].
	^ nil! !

!AltGoToSuperMethodCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/6/2012 21:46'!
icon
	^ nil! !

!AltGoToSuperMethodCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/6/2012 23:08'!
isActive
	^ true! !

!AltGoToSuperMethodCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/30/2012 14:35'!
isEnabled
	requestor selectedNode sourceClass
		allSuperclassesDo: [ :each | 
			(each includesSelector: requestor selectedNode item item)
				ifTrue: [ ^ true ] ].
	^ false! !

!AltGoToSuperMethodCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/15/2012 11:57'!
keystroke
	^ $n command, $s! !

!AltGoToSuperMethodCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/6/2012 21:46'!
label
	^ 'Super ...'! !

AltCommand subclass: #AltGoToSuperclassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltGoToSuperclassCommand commentStamp: '<historical>' prior: 0!
This command moves the selection to the superclass.
!

!AltGoToSuperclassCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/17/2012 15:58'!
execute
	"Find the superclass and jump to it."

	| found aClass nPath aNode tmPath |
	aClass := requestor selectedNode item item superclass.
	AltBrowser rootItems contents
		do: [ :each | 
			| res |
			(res := each findClass: aClass) notNil
				ifTrue: [ found := res ] ].
	requestor selectPathForAbstractItem: found! !

!AltGoToSuperclassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/4/2012 12:19'!
icon
	^ nil! !

!AltGoToSuperclassCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/4/2012 13:03'!
isActive
	^ true! !

!AltGoToSuperclassCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/4/2012 13:03'!
isEnabled
	^ true! !

!AltGoToSuperclassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/15/2012 11:58'!
keystroke
	^ $n command, $s! !

!AltGoToSuperclassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/4/2012 12:58'!
label
	^ 'Superclass'! !

AltCommand subclass: #AltImplementorsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltImplementorsCommand commentStamp: '<historical>' prior: 0!
Return the implementors of a selection!

!AltImplementorsCommand methodsFor: 'execution' stamp: 'ThierryGoubier 9/30/2012 14:35'!
execute
	SystemNavigation default browseAllImplementorsOf: requestor selectedNode item item! !

!AltImplementorsCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/10/2012 22:10'!
icon
	^ #smallFindIcon! !

!AltImplementorsCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/7/2012 16:32'!
isActive
	^ true! !

!AltImplementorsCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/7/2012 16:32'!
isEnabled
	^ true! !

!AltImplementorsCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/7/2012 16:31'!
label
	^ 'Implementors'! !

AltCommand subclass: #AltImplementorsTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltImplementorsTextCommand commentStamp: '<historical>' prior: 0!
Browse all implementors of the selected selector.!

!AltImplementorsTextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/1/2012 21:54'!
execute
	target implementorsOfIt! !

!AltImplementorsTextCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/14/2012 22:44'!
isActive
	^ true! !

!AltImplementorsTextCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/14/2012 22:43'!
isEnabled
	^ true! !

!AltImplementorsTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/14/2012 22:41'!
keystroke
	^ $m ctrl! !

!AltImplementorsTextCommand methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 9/14/2012 22:39'!
label
	^ 'Implementors...'! !

AltCommand subclass: #AltNewClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltNewClassCommand commentStamp: '<historical>' prior: 0!
This command creates a new class
!

AltCommand subclass: #AltNextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltNextCommand commentStamp: '<historical>' prior: 0!
History next command.
!

!AltNextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 9/30/2012 12:48'!
execute
	requestor selectPathForAbstractItem: requestor history next key item! !

!AltNextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/4/2012 15:34'!
icon
	^ #smallForwardIcon! !

!AltNextCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/4/2012 15:37'!
isActive
	^ true! !

!AltNextCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/4/2012 15:37'!
isEnabled
	^ requestor history hasNext! !

!AltNextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/15/2012 11:55'!
keystroke
	^ Character arrowRight command! !

!AltNextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/4/2012 15:37'!
label
	^ 'Forward'! !

AltCommand subclass: #AltNextSiblingClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltNextSiblingClassCommand commentStamp: '<historical>' prior: 0!
This command jumps to the sibling class according to the inheritance: the next class which has the same superclass than the selected class.!

!AltNextSiblingClassCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/17/2012 15:58'!
execute
	| found aClass aClassIndex siblings nextClass |
	aClass := requestor selectedNode item item.
	siblings := aClass superclass subclasses.
	aClassIndex := siblings indexOf: aClass.
	nextClass := siblings at: ((aClassIndex rem: siblings size) + 1).
	AltBrowser rootItems
		do: [ :each | 
			| res |
			(res := each findClass: nextClass) notNil
				ifTrue: [ found := res ] ].
	requestor selectPathForAbstractItem: found! !

!AltNextSiblingClassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/15/2012 11:22'!
icon
	^ nil! !

!AltNextSiblingClassCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/15/2012 11:32'!
isActive
	^ true! !

!AltNextSiblingClassCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/30/2012 14:35'!
isEnabled
	^ requestor selectedNode item item superclass notNil! !

!AltNextSiblingClassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/15/2012 11:22'!
keystroke
	^ $n command, $d! !

!AltNextSiblingClassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/15/2012 11:21'!
label
	^ 'Next sibling class'! !

AltCommand subclass: #AltPasteCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltPasteCommand commentStamp: '<historical>' prior: 0!
This command paste something which has been cut first.!

!AltPasteCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/17/2012 15:58'!
execute
	"Get the temporary from the AltBrowser and try a move (a drop, maybe ?)"

	(requestor selectedNode item dropItem: AltBrowser temporary) isNil
		ifFalse: [ AltBrowser temporary: nil ]! !

!AltPasteCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/9/2012 23:23'!
icon
	^ #smallPasteIcon! !

!AltPasteCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/9/2012 23:24'!
isActive
	^ true! !

!AltPasteCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/9/2012 23:25'!
isEnabled
	^ true! !

!AltPasteCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/9/2012 23:26'!
keystroke
	^ $v ctrl! !

!AltPasteCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/9/2012 23:22'!
label
	^ 'Paste'
	! !

AltCommand subclass: #AltPasteTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltPasteTextCommand commentStamp: '<historical>' prior: 0!
An ABPasteTextCommand : Paste text from Clipboard. Directly target the editor; neither the model nor the widget have methods for handling that.
!

!AltPasteTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!AltPasteTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!AltPasteTextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/1/2012 21:55'!
execute
	target textMorph editor replace: target trueSelectionInterval with: Clipboard clipboardText and: [  ]! !

!AltPasteTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:27'!
group
	^ #clipboard! !

!AltPasteTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/17/2012 23:18'!
icon
	^ #smallPasteIcon! !

!AltPasteTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:22'!
isActive
	^ true! !

!AltPasteTextCommand methodsFor: 'testing' stamp: 'ThierryGoubier 7/26/2012 07:52'!
isEnabled
	^ Clipboard clipboardText notEmpty! !

!AltPasteTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:53'!
keystroke
	^ $v ctrl! !

!AltPasteTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:14'!
label
	^ 'Paste'! !

!AltPasteTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:29'!
order
	^ '3'! !

AltCommand subclass: #AltPreviousCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltPreviousCommand commentStamp: '<historical>' prior: 0!
History previous in the Alt Browser
!

!AltPreviousCommand methodsFor: 'execution' stamp: 'ThierryGoubier 9/30/2012 12:46'!
execute
	requestor selectPathForAbstractItem: requestor history previous key item! !

!AltPreviousCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/4/2012 15:27'!
icon
	^ #smallBackIcon! !

!AltPreviousCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/4/2012 15:32'!
isActive
	^ true! !

!AltPreviousCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/4/2012 15:33'!
isEnabled
	^ requestor history hasPrevious! !

!AltPreviousCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/15/2012 11:54'!
keystroke 
	^ Character arrowLeft command! !

!AltPreviousCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/4/2012 15:22'!
label
	^ 'Back'! !

AltCommand subclass: #AltRBClassRenameCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltRBClassRenameCommand commentStamp: '<historical>' prior: 0!
This class is a class renaming command.!

!AltRBClassRenameCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/15/2012 14:38'!
execute
	| sItem |
	sItem := requestor selectedNode item.
	(RBRenameClassRefactoring
		rename: sItem item theNonMetaClass
		to:
			(UIManager default
				request: 'Enter the new class name:'
				initialAnswer: sItem item theNonMetaClass name)) execute.
	requestor selectPathForAbstractItem: sItem! !

!AltRBClassRenameCommand methodsFor: 'testing' stamp: 'ThierryGoubier 10/10/2012 09:11'!
isActive
	^ true! !

!AltRBClassRenameCommand methodsFor: 'testing' stamp: 'ThierryGoubier 10/10/2012 09:11'!
isEnabled
	^ true! !

!AltRBClassRenameCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 10/10/2012 09:12'!
keystroke
	^ $r command! !

!AltRBClassRenameCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 10/10/2012 09:12'!
label
	^ 'Rename'! !

AltCommand subclass: #AltRBFormatCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltRBFormatCommand commentStamp: '<historical>' prior: 0!
This class is for the source code formatting command.
!

!AltRBFormatCommand methodsFor: 'execution' stamp: 'ThierryGoubier 9/28/2012 21:49'!
execute
	"Code derived from ORFormatCmd (OmniBrowser) and simplified. Will fail silently if the code is incorrect."

	| source tree formatted |
	source := target text asString.
	tree := RBParser parseMethod: source onError: [ :msg :pos | ^ self ].
	formatted := tree formattedCode.
	formatted = source
		ifTrue: [ ^ self ].
	target
		editString: formatted;
		hasUnacceptedEdits: true! !

!AltRBFormatCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:31'!
icon
	^ nil! !

!AltRBFormatCommand methodsFor: 'testing' stamp: 'ThierryGoubier 8/1/2012 16:36'!
isActive
	^ true! !

!AltRBFormatCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:31'!
keystroke
	^ $r ctrl! !

!AltRBFormatCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/12/2012 15:12'!
label
	^ 'Format'! !

AltCommand subclass: #AltRBRedoCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltRBRedoCommand commentStamp: '<historical>' prior: 0!
This is the RB redo command.!

!AltRBRedoCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/10/2012 09:07'!
execute
	RBRefactoryChangeManager instance redoOperation! !

!AltRBRedoCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 10/10/2012 09:05'!
icon
	^ #smallRedoIcon! !

!AltRBRedoCommand methodsFor: 'testing' stamp: 'ThierryGoubier 10/10/2012 09:05'!
isActive
	^ true! !

!AltRBRedoCommand methodsFor: 'testing' stamp: 'ThierryGoubier 10/10/2012 09:06'!
isEnabled
	^ RBRefactoryChangeManager instance hasRedoableOperations! !

!AltRBRedoCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 10/10/2012 09:05'!
keystroke
	^ $y ctrl! !

!AltRBRedoCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 10/10/2012 09:05'!
label
	"Depends on whether there is anything to redo or not."

	RBRefactoryChangeManager instance hasRedoableOperations
		ifTrue: [ ^ 'Redo ' , RBRefactoryChangeManager instance redoChange name ]
		ifFalse: [ ^ 'Redo ...' ]! !

AltCommand subclass: #AltRBUndoCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltRBUndoCommand commentStamp: '<historical>' prior: 0!
An AltRBUndoCommand is for handling the undo facilities of RB.!

!AltRBUndoCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/9/2012 23:14'!
execute
	RBRefactoryChangeManager instance undoOperation! !

!AltRBUndoCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 10/10/2012 09:01'!
icon
	^ #smallUndoIcon! !

!AltRBUndoCommand methodsFor: 'testing' stamp: 'ThierryGoubier 10/9/2012 23:13'!
isActive
	^ true! !

!AltRBUndoCommand methodsFor: 'testing' stamp: 'ThierryGoubier 10/9/2012 23:14'!
isEnabled
	^ RBRefactoryChangeManager instance hasUndoableOperations! !

!AltRBUndoCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 10/9/2012 22:55'!
keystroke
	^ $z ctrl! !

!AltRBUndoCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 10/9/2012 23:22'!
label
	"Depends on the state of the undoing facility of RB and what it contains."

	RBRefactoryChangeManager instance hasUndoableOperations
		ifTrue: [ ^ 'Undo ' , RBRefactoryChangeManager instance undoChange name ]
		ifFalse: [ ^ 'Undo ...' ]! !

AltCommand subclass: #AltRebuildItemCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltRebuildItemCommand commentStamp: '<historical>' prior: 0!
This class forces a rebuild of an item in the tree.
!

!AltRebuildItemCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/17/2012 15:58'!
execute
	"requestor selectedItem rebuildChildren."
	AltBrowser aNodeToRebuilt: requestor selectedNode item! !

!AltRebuildItemCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/5/2012 09:08'!
icon
	^ #smallDebugIcon! !

!AltRebuildItemCommand methodsFor: 'testing' stamp: 'ThierryGoubier 10/17/2012 15:58'!
isActive
	^ AltBrowser debug! !

!AltRebuildItemCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/30/2012 14:36'!
isEnabled
	^ requestor selectedNode notNil! !

!AltRebuildItemCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/5/2012 08:59'!
keystroke
	^ nil! !

!AltRebuildItemCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/5/2012 09:00'!
label
	^ 'Rebuild It'! !

AltCommand subclass: #AltRedoTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltRedoTextCommand commentStamp: '<historical>' prior: 0!
An ABRedoTextCommand calls the text editor redo command.
!

!AltRedoTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!AltRedoTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!AltRedoTextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/1/2012 21:55'!
execute
	target textMorph editor redo! !

!AltRedoTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 10:38'!
group
	^ #adapting! !

!AltRedoTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/17/2012 23:18'!
icon
	^ #smallRedoIcon! !

!AltRedoTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:22'!
isActive
	^ true! !

!AltRedoTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:54'!
keystroke
	^ $j ctrl! !

!AltRedoTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:20'!
label
	^ 'Redo'! !

AltCommand subclass: #AltRemoveClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltRemoveClassCommand commentStamp: '<historical>' prior: 0!
This command removes a class.!

!AltRemoveClassCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/10/2012 14:08'!
execute
	| message className classToRemove result |
	requestor okToChange
		ifFalse: [ ^ false ].
	classToRemove := requestor selectedNode item item.
	(RBRemoveClassRefactoring classNames: {(classToRemove name)}) execute.
	^ nil! !

!AltRemoveClassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/20/2012 21:50'!
icon
	^ #smallDeleteIcon! !

!AltRemoveClassCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/16/2012 08:05'!
isActive
	^ true! !

!AltRemoveClassCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/16/2012 08:05'!
isEnabled
	^ true! !

!AltRemoveClassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/17/2012 22:00'!
keystroke
	^ Character delete asShortcut! !

!AltRemoveClassCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/16/2012 08:01'!
label
	^ 'Remove'! !

AltCommand subclass: #AltRemoveMethodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltRemoveMethodCommand methodsFor: 'execution' stamp: 'ThierryGoubier 9/30/2012 14:37'!
execute
	"As simple as that ?"
	
	requestor selectedNode sourceClass removeSelector: requestor selectedNode item item! !

!AltRemoveMethodCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/20/2012 21:49'!
icon
	^ #smallDeleteIcon! !

!AltRemoveMethodCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/6/2012 22:13'!
isActive
	^ true! !

!AltRemoveMethodCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/6/2012 22:10'!
isEnabled
	^ true! !

!AltRemoveMethodCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/17/2012 22:00'!
keystroke
	^ Character delete asShortcut! !

!AltRemoveMethodCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/6/2012 22:06'!
label
	^ 'Remove'! !

AltCommand subclass: #AltRemovePackageCategoryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltRemovePackageCategoryCommand commentStamp: '<historical>' prior: 0!
This class does a remove item on the selected item (package category : anything else requires specific system commands.)!

!AltRemovePackageCategoryCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/17/2012 15:58'!
execute
	"Remove the package category."

	| item |
	item := requestor selectedNode item.
	item parentNode notNil
		ifTrue: [ item parentNode removeChildItem: item ]
		ifFalse: [ AltBrowser rootItems remove: item ].
	AltBrowser announcer announce: (AltNodeRemoved node: item)! !

!AltRemovePackageCategoryCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/31/2012 15:26'!
icon
	^ #smallCutIcon! !

!AltRemovePackageCategoryCommand methodsFor: 'testing' stamp: 'ThierryGoubier 7/31/2012 15:27'!
isActive
	^ true! !

!AltRemovePackageCategoryCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/17/2012 22:02'!
keystroke
	^ Character delete asShortcut! !

!AltRemovePackageCategoryCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/9/2012 23:39'!
label
	^ 'Remove'! !

AltCommand subclass: #AltRemoveProtocolCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltRemoveProtocolCommand commentStamp: '<historical>' prior: 0!
This command removes a protocol!

!AltRemoveProtocolCommand methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 9/30/2012 14:38'!
execute
	| tClass tItem |
	
	tClass := requestor selectedNode sourceClass.
	tItem := requestor selectedNode.
	tClass removeCategory: tItem item item! !

!AltRemoveProtocolCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/18/2012 14:47'!
icon
	^ #smallDeleteIcon! !

!AltRemoveProtocolCommand methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 8/30/2012 16:13'!
isActive
	^ true! !

!AltRemoveProtocolCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/17/2012 22:01'!
keystroke
	^ Character delete asShortcut! !

!AltRemoveProtocolCommand methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 9/17/2012 22:03'!
label
	^ 'Remove'! !

AltCommand subclass: #AltSendersCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltSendersCommand methodsFor: 'execution' stamp: 'ThierryGoubier 9/30/2012 14:38'!
execute
	"Execute an all senders of."
	
	SystemNavigation default browseAllCallsOn: requestor selectedNode item item! !

!AltSendersCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/10/2012 22:11'!
icon
	^ #smallFindIcon! !

!AltSendersCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/8/2012 11:03'!
isActive
	^ true! !

!AltSendersCommand methodsFor: 'testing' stamp: 'ThierryGoubier 9/8/2012 11:03'!
isEnabled
	^ true! !

!AltSendersCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/8/2012 11:01'!
label
	^ 'Senders'! !

AltCommand subclass: #AltUndoTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!AltUndoTextCommand commentStamp: '<historical>' prior: 0!
An ABUndoTextCommand calls the text editor undo command.!

!AltUndoTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!AltUndoTextCommand class methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!AltUndoTextCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/1/2012 21:55'!
execute
	target textMorph editor undo! !

!AltUndoTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 10:38'!
group
	^ #adapting! !

!AltUndoTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/17/2012 23:19'!
icon
	^ #smallUndoIcon! !

!AltUndoTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:22'!
isActive
	^ true! !

!AltUndoTextCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:54'!
keystroke
	^ $z ctrl! !

!AltUndoTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:20'!
label
	^ 'Undo'! !

!PluggableTextMorph methodsFor: '*Alt-Browser' stamp: 'ThierryGoubier 9/25/2012 23:29'!
readSelection
	"Return the selection text as remembered by the PluggableTextMoprh, even if not in focus."

	^ textMorph editor text copyFrom: selectionInterval first to: selectionInterval last! !

!PluggableTextMorph methodsFor: '*Alt-Browser' stamp: 'ThierryGoubier 7/26/2012 07:48'!
trueSelection
	"Return the selection text as remembered by the PluggableTextMoprh, even if not in focus."

	^ textMorph editor text copyFrom: selectionInterval first to: selectionInterval last! !

!PluggableTextMorph methodsFor: '*Alt-Browser' stamp: 'ThierryGoubier 7/25/2012 23:58'!
trueSelectionInterval
	^ selectionInterval! !
AltBrowser initialize!
